<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

  /**
   **  address_book_import.php
   **    
   **  Copyright (c) 1999-2000 The SquirrelMail development team
   **  Licensed under the GNU GPL. For full terms see the file COPYING.
   **            
   **    Import csv files for address book
   **      This takes a comma delimited file uploaded from addressbook.php
   **      and allows the user to rearrange the field order to better
   **      fit the address book. A subset of data is manipulated to save time.
   **
   **   This was a part of the Squirrelmail source tree and is being ported
   **   to a plugin.
   **/

define( 'SM_PATH' , '../../');

require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'functions/page_header.php');

    sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);  
    sqgetGlobalVar('sfield',  $sfield,      SQ_POST);  
    global $max_file_addressbook_size, $fieldarrayabook;

   // Local Variables
   $errorstring = '';
   $error = 0;
   $csvmax = 0;
   $key = 0;
   $x = 0;
   $row = 0;
   $cols = 0;
   $colspan = 0;
   $c = 0;
   $reorg = array();
   $selrow = '';

    // Grab the needed variable
   $finish = (isset($_POST['OK'])?$_POST['OK']:'0');

// Here we will split the script into finished and not finished parts 
if (!isset($OK) || !$OK) {

    displayHtmlHeader( _("Addressbook"), '' );

   // Check to make sure the user actually put a file in the upload file box. 
   $smusercsv = $_FILES['smusercsv'];
 
   if (!$smusercsv || $smusercsv['tmp_name'] == '' || $smusercsv['size'] == 0 || $smusercsv['size'] > $max_file_addressbook_size) {
	echo '<body onload="document.location.replace(\''.$base_uri.'plugins/abook_import_export/importCSV.php?error=1\')">'."\n";
	echo '</body></html>';	
        exit;
   }

   /**
    ** Use file() to get the data from the php temp file into an array so 
    ** that we don't have to save files on the server. 
    **/

   // These shouldn't be set at all at this point. 
   $_SESSION['csvdata'] = array(); 
   $_SESSION['csvorder'] = array();

   $csvfile = @fopen($smusercsv['tmp_name'],"r");

   if (!$csvfile) {
	echo '<body onload="document.location.replace(\''.$base_uri.'plugins/abook_import_export/importCSV.php?error=2\')">'."\n";
	echo '</body></html>';	
        exit;
   }
   
   // splitta files CSV con separatore di campo definito precedentemente.
   while ($csvarray = fgetcsv($csvfile,4096,$sfield)) { 
      // Let fgetcsv deal with splitting the line into it's parts. (I.E. it deals with quoted commas right) 
      $temp = CSVProcess($csvarray);
      
      if (count($temp) >2) {
         $_SESSION['csvdata'][$key] = $temp;
         $key++;
      }
      elseif (isset($temp[0])) { 
         //This means it returned an error
         $errorstring .= $temp[0] . '<p>';
      } 

      // After this, the function was just doing some calculations, and returned without a problem.
      if(count($csvarray) > $csvmax) {
         $csvmax = count($csvarray);
      }
   }

   unset($_SESSION['csvorder']);

    if ($errorstring) {
	echo '<body onload="document.location.replace(\''.$base_uri.'plugins/abook_import_export/importCSV.php?error=3\')">'."\n";
	echo '</body></html>';	
        exit;
    }

   echo '<body>'."\n";
   echo addForm($PHP_SELF, 'POST','formabi');
   echo '<TABLE WIDTH="100%" CELLPADDING=0 ALIGN="left" VALIGN="top" CELLSPACING="0">
    <TR><TD>    
        <TABLE CLASS="border" WIDTH="100%" CELLPADDING=0 ALIGN="left" VALIGN="top" CELLSPACING="1">
	    <TR><TD class="nav">';    
	    echo addHidden('OK',_("OK"));
	    echo addButton(_("OK"), '', '','','formabi');
    echo '  </TD></TR>
	</TABLE>
    </TD></TR>
    <TR><TD>    
	<TABLE CLASS="border" WIDTH="100%" CELLPADDING=0 ALIGN="left" VALIGN="top" CELLSPACING="1">';

   // Here I will create the headers that I want.
   echo '
   <TR CLASS="nav" ALIGN="center">
   <TD WIDTH="1">' .  codeHTML(_("Omit")) . '</TD>
   '; // The Omit column

   for($x = 0; $x < $csvmax; $x++) { // The Drop down boxes to select what each column is
      echo '<TD ALIGN="left" CLASS="addressbookth">';
        create_Select($csvmax,$x); 
      echo '</TD>
      ';
   }

   echo '</TR>
   ';

   do {
      if (count($_SESSION['csvdata'][$row]) > (count($fieldarrayabook)-1)) {    // This if ensures the minimum number of columns
         $cols = count($_SESSION['csvdata'][$row]);    // so importing can function for all 5 fields
      } else {
         $cols = count($fieldarrayabook)-1;
      }        

      $colspan = $cols + 1;
      if ($row % 2) {                   // Set up the alternating colored rows
         echo '<TR class="nav2">
         ';
      } else {
         echo '<TR class="nav">
         ';
      }

      echo '<TD WIDTH="1">'.addCheckBox('sel'.$row, FALSE).'</TD>';
    
      for($c = 0; $c < $cols; $c++) { // For each column in the current row
         if ($_SESSION['csvdata'][$row][$c] != "") {                                // if not empty, put data in cell.
            echo '<TD NOWRAP>' . codeHTML($_SESSION['csvdata'][$row][$c]) . '</TD>
            ';
         } else {                                          // if empty, put space in cell keeping colors correct.
            echo '<TD>&nbsp;</TD>
            ';
         }
      }
      echo '</TR>
      ';
      $row++;
   } while ($row < count($_SESSION['csvdata']));
   
   echo '</TABLE></TD></TR></TABLE>';
   
} else {
   /** 
    **   $abook ---->Setup the addressbook functions for Pallo's Addressbook.
    **/

   $book = addressbook_init(true, true); 
   $abook = $book[0];
   $gabook = $book[1];

   displayHtmlHeader( _("Addressbook"), '' );   
   echo '<body><table height="100%" width="100%" cellpadding=2 cellspacing=3 class="border">';
   do {
      if (count($_SESSION['csvdata'][$row]) > (count($fieldarrayabook)-1)) {    // This if ensures the minimum number of columns
         $cols = count($_SESSION['csvdata'][$row]);    // so importing can function for all 5 fields
      } else {
         $cols = count($fieldarrayabook)-1;
      }  
            
      for ($c=0; $c < $cols; $c++) {
	 $reorg[$c]='';
         // Reorganize the data to fit the header cells that the user chose
         // concatenate fields based on user input into text boxes.
         $column = "COL$c";
         
         if($_POST[$column] != _("Do Not Include"))  {
             $reorg[$_POST[$column]] = $_SESSION['csvdata'][$row][$c];
         }
      }
      $_SESSION['csvdata'][$row] = $reorg;
      unset($reorg); // So that we don't get any weird information from a previous rows

      // If finished, do the import. This uses Pallo's excellent class and object stuff 
      $selrow = 'sel' . $row;
      
      if (!isset($_POST[$selrow])) {
	 $addaddr = array();
	 foreach ($fieldarrayabook as $key => $v) {
	    if ($key == "idrub" || $key == "SendPredefined" || $key == "syncr") { continue; }
	    $addaddr[$key]=$_SESSION['csvdata'][$row][$key];  
	 }
	 if ($addaddr["Email"]) { $addaddr["SendPredefined"] = 2; }
	 else { $addaddr["SendPredefined"] = 1; }    
	 $addaddr["syncr"] = 1;
         if (!$abook->add($addaddr,$abook->localbackend)) {
            $errorstring .= $abook->error . "\n";
            $error++;
         }

         unset($addaddr); // Also so we don't get any weird information from previous rows
      }
      $row++;
      
   } while($row < count($_SESSION['csvdata']));

   unset($_SESSION['csvdata']); // Now that we've uploaded this information, we dont' need this variable anymore, aka cleanup

   // Print out that we've completed this operation
   if ($error) {
	echo '<tr><td class="error" align="center" valign="top">';
            echo codeHTML(_("There were errors uploading the data, as listed below. Entries not listed here were uploaded.") . "\n " . $errorstring);
	echo '</td></tr>';
   } else {
	echo '<tr><td class="success" align="center" valign="middle">';
    	    echo codeHTML(_("Upload Completed!"));
	echo '</td></tr>';
   }
    echo '<tr><td onClick="parent.opener.location.reload(); window.close();" class="nav" align="center">';
	echo codeHTML(_("Close"));
    echo '</td></tr></table>';
    echo '<script language="javascript">window.resizeTo(450,200)</script>';  
    echo '</body></html>';
}

// Send the field numbers entered in the text boxes by the user back to this script for more processing
// email is handled differently, not being an array
function create_Select($csvmax,$column) {
    global $fieldarrayabook;
    foreach ($fieldarrayabook as $k => $id) {
        $fieldarrayabookposition[$id['idfile']] = array( value => $k, label => $id['label']);
    }
    ksort ($fieldarrayabookposition);
    reset ($fieldarrayabookposition);
    array_shift($fieldarrayabookposition);

    $new_option = array();

    if($column > count($fieldarrayabookposition)) {
	$column = count($fieldarrayabookposition); // So we have only our normal choices. 
    }    
    $selected='';
    for($temp = 0; $temp < count($fieldarrayabookposition); $temp++) {
      if ($column == $temp) { $selected = $fieldarrayabookposition[$temp]["value"]; }
      if ($temp == count($fieldarrayabookposition)) {
	    $new_option[$fieldarrayabookposition[$temp]["value"]] = _("Do Not Include");
      } else {
	    $new_option[$fieldarrayabookposition[$temp]["value"]] = _($fieldarrayabookposition[$temp]['label']);
      }
    }
    $new_option[_("Do Not Include")] = _("Do Not Include");
    if (!$selected) { $selected = _("Do Not Include"); }    
    echo addSelect("COL$column", $new_option, $selected, TRUE);
}

function CSVProcess($row) {
   if (preg_grep("/((?:\/ou\=)|(?:\/cn\=)|(?:\/o\=))/",$row)) {
      $temprow = join(",",$row);
      $return[] = codeHTML($temprow)." <br> - ". codeHTML(_("contains LDIF email address. This is not currently supported.")."\n");
      return $return;
   }
   
   if (preg_grep("/((?:First Name)|(?:Last Name)|(?:E-mail Address))/",$row)) {
      foreach($row as $key => $value) {
         if ($value == "First Name" ) { 
            if(isset($_SESSION['csvorder'][$key])) { 
               $_SESSION['csvorder'][1] = $_SESSION['csvorder'][$key]; 
            }
            else { 
               $_SESSION['csvorder'][1]= $key; 
            }
         }
         if ($value == "Last Name" ) { 
            if(isset($_SESSION['csvorder'][$key])) { 
               $_SESSION['csvorder'][2] = $_SESSION['csvorder'][$key]; 
            }
            else { 
               $_SESSION['csvorder'][2]= $key; 
            }
         }
         if ($value == "E-mail Address" ) { 
            if(isset($_SESSION['csvorder'][$key])) { 
               $_SESSION['csvorder'][3] = $_SESSION['csvorder'][$key]; 
            }
            else { 
               $_SESSION['csvorder'][3]= $key; 
            }
         }
      }
      return array();
   }
   
   if (count($_SESSION['csvorder']) > 0) { // This is swapping elements to make firstname, last name, and email be in the 1,2,3 spot, respectively
      foreach($_SESSION['csvorder'] as $key => $value) {
         $temp = $row[$key];
         $row[$key] = $row[$value];
         $row[$value] = $temp;
      }
      return $row;
   }
   
   return $row;
}
  
?>
</FORM>
</BODY>
</HTML>
