<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
 * GPG Plugin help file framework. Creates the HTML structure,
 * sets the theme, and includes the help article file.
 *
 * Copyright (c) 2003 Braverock Ventures
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * @package gpg
 * @author Walter Torres
 *
 * $Id: gpg_recipientlist.php,v 1.2 2003/12/30 19:04:29 ke Exp $
 *
 * @todo check help file include for security breach in gpg_help.php
 */
if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else echo "unable to define SM_PATH in gpg_decrypt_attach.php, exiting abnormally";
}

require_once(SM_PATH.'plugins/gpg/gpg_keyring.php');
require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'functions/forms.php');

sqgetGlobalVar('help', $help, SQ_GET);
sqgetGlobalVar('recipients', $recipients, SQ_SESSION);
sqgetGlobalVar('base_uri', $base_uri,     SQ_SESSION);
if (!isset($help)) { $_GET['help'] = 'base'; } 

require_once(SM_PATH.'plugins/gpg/modules/gpg_popup_header.php');

echo '<tr>
        <td align="left" width="100%" valign="top">
            <table width="100%" height="100%" cellpadding="0" valign="top" class="border" cellspacing="2" border="0">';

// this stuff should get loaded with the load_prefs.php file, but it isn't,
// so we hack it here so our colors are correct.
// only hack for newer SM versions. older ones work fine
if (substr($version, 2,4) >= 3.1) {
   $chosen_theme = getPref($data_dir, $username, 'chosen_theme');
   $chosen_theme = preg_replace("/(\.\.\/){1,}/", SM_PATH, $chosen_theme);
   if (isset($chosen_theme) && (file_exists($chosen_theme))) {
      @include_once($chosen_theme);
   }
}
// end color hack

// ===============================================================
$section_title = _("GPG Recipient List");
gpg_page_title( $section_title );
// ===============================================================

if (count($recipients)) {
    foreach($recipients as $r) {
	echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
	    echo decodeHeader($r->getAddress(true));
	echo '</td></tr>';
    }
}

echo '<tr valign="top"><td width="100%" height="1%" align="center" class="nav">';
    echo addButton(_("Done"), '','','self.close();','','',1,1);
echo '</td></tr>';

echo '<tr>
        <td align="left" width="100%" class="nav">
                    &nbsp;
                </td>
            </tr>';

echo '</table>';

require_once(SM_PATH.'plugins/gpg/modules/gpg_module_footer.php');

/**
 * $Log: gpg_recipientlist.php,v $
 * Revision 1.2  2003/12/30 19:04:29  ke
 * -changed single to double quotes for translation purposes
 *
 * Revision 1.1  2003/11/18 15:32:04  walter
 * - initial submition
 * - framework to display recipient list from decrypted messages
 * Bug 71
 *
 * Revision 1.4  2003/11/04 21:38:40  brian
 * change to use SM_PATH
 *
 * Revision 1.3  2003/10/28 23:56:40  walter
 * - updated structure
 * Bug 79
 *
 * Revision 1.2  2003/10/22 15:25:18  brian
 * - added page header block
 * - removed trailing LF's after closing ?>
 *
 * Revision 1.1  2003/10/21 22:11:37  walter
 * - linitial entry
 * - page structure set
 * Bug 79
 **/
?>
