<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
 * keyserver.mod
 * ----------------
 * Copyright (c) 2002-2003 Braverock Ventures
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Key Server lookup screen
 *
 * Unfortunately, we use HTTP screen scraping to look up keys.
 * Ideally, we would use HKS or LDAP to look up keys.
 *
 * $Id: keyserver.mod,v 1.21 2003/12/30 19:05:16 ke Exp $
 *
 * $Author: ke $
 * $Date: 2003/12/30 19:05:16 $
 *
 * @todo - Fix includes to use SM_PATH
 * @todo - Add support for HKS or LDAP keyservers.
 *       Ref: http://www.braverock.com/bugzilla/show_bug.cgi?id=43
 */

//make the global $debug setting available here
global $debug;

if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else echo "unable to define SM_PATH in genkey.php, exiting abnormally";
}
require_once(SM_PATH.'plugins/gpg/gpg_key_functions.php');
require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'functions/forms.php');

//extract necessary variables from the $_POST
sqgetGlobalVar('search', $search, SQ_POST);
sqgetGlobalVar('keyID', $keyID, SQ_POST);

if (!$search and !$keyID) {
    $id=0;

    gpg_page_title ( _("Keyserver Options"));

    echo addForm('#','POST','form_search_key')."\n";
    echo addHidden('MAX_FILE_SIZE',100000)."\n";
    echo addHidden('MOD','keyserver')."\n";

    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">';

    echo codeHTML(_("Choose your Default Keyserver")).":&nbsp";
	$key_server_list=array();
	for ($i = 0; $i < $GLOBALS['GPG_SYSTEM_OPTIONS']['keyservers']; $i++) {
		$key_server_list[] = $GLOBALS['GPG_SYSTEM_OPTIONS']['keyserver' . $i];
	};
	$defaultkeyserver = getPref($data_dir,$username,'keyserver');
	if ($defaultkeyserver) {
		array_unshift($key_server_list,$defaultkeyserver);
	}
	echo addSelect('keyserver',$key_server_list,$defaultkeyserver);
	echo addCheckBox('default',false,1);
    echo codeHTML(_("Make this my default keyserver"));
    echo '</td></tr>'."\n";
    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">'."\n";
    echo codeHTML(_("Enter Search text below to search for a key to import"))."\n";
    echo '</td></tr>'."\n";
    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">'."\n";
    echo codeHTML( _("Search text may be an email address or an OpenPGP(PGP/GPG) Key ID"))."\n";
    echo '</td></tr>'."\n";
    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">'."\n";
    echo addInput('search_keyid','',60)."\n";
    echo addHidden('search',1);
    echo '</td></tr>';
    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top" align="center">';
	echo addSubmit(_("Search for Key"),'search','','','form_search_key');
    echo '</td></tr>'.'</form>';
}

if ($search) {
    global $keyserver;
    //extract necessary variables from the $_POST
    sqgetGlobalVar('default', $default, SQ_POST);
    sqgetGlobalVar('keyserver', $keyserver, SQ_POST);
    sqgetGlobalVar('search_keyid', $search_keyid, SQ_POST);

    gpg_page_title ( _("Choose a Key to Import"));

    if ($default == 1) {
        setPref($data_dir,$username,'keyserver',$keyserver);
        echo codeHTML(_("Default Keyserver set to:")." $keyserver");
    };

    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">';
	$default_keyserver = getPref($data_dir,$username,'keyserver',$keyserver);
	echo codeHTML(_("Default Keyserver")).':&nbsp;'.$default_keyserver."<BR>\n";
    echo '</td></tr>'."\n";
    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">';
	echo codeHTML(_("Using Keyserver")).':&nbsp;'.$keyserver."\n";
    echo '</td></tr>'."\n";

   if ($search_keyid!="") {
        $foundkeys = array();
        $foundkeys = gpg_keyserver_findkey($search_keyid,$debug);
        //ob_start();
	echo addForm('#','POST')."\n";
	echo addHidden('MAX_FILE_SIZE',100000)."\n";
	echo addHidden('MOD','keyserver')."\n";
    	echo addHidden('keyserver',$keyserver)."\n";
	echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">'."\n";
        if (is_array($foundkeys)) {
		echo codeHTML(_("Select a key to import from the list below."));
	    echo '</td></tr>';
	    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">'."\n";
		echo codeHTML(_("If you do not see the key you wish to import, you may go back and enter different search terms or select a different keyserver."))."\n";
	    echo '</td></tr>';
		echo '<tr valign="top"><td width="100%" height="1%" valign="top">'."\n";
		    echo '<table border=0 cellpadding=2 cellspacing=1 width="100%" align="center">';
			//set up the table headers
			echo
				  "\n<tr>"
				. '<td class="optionlink" align="center">'. codeHTML(_("Key ID")) .'</th>'
				. '<td class="optionlink" align="center">'. codeHTML(_("Name")) .'</th>'
				. '<td class="optionlink" align="center">'. codeHTML(_("Email Address")) .'</th>'
				. '<td class="optionlink" align="center">'. codeHTML(_("Key Date")) .'</th>'
				. '</tr>';
			if (count($foundkeys) != 0) {
				foreach ($foundkeys as $key) {
					echo
					  "\n<tr>"
					. '<td class="nav">'. addRadioBox('keyID',false,$key['lastkey']).'&nbsp;'.$key['lastkey'].'</td>'
					. '<td class="nav">'. codeHTML($key['tmpname']) . '</td>'
					. '<td class="nav">'. codeHTML($key['tmpemail']) . '</td>'
					. '<td class="nav">'. codeHTML($key['lastdate']) . '</td>'
					. '</tr>';
				}; //end foreach
			} else {
			    echo
			        "\n<tr>"
				. '<td class="nav" colspan=4 align="center">'. codeHTML(_("No keys found")) . '</td>'
				. '</tr>';
			}
        	    echo '</table>';
		echo '</td></tr>'."\n";
		echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top" align="center">'."\n";
		    echo addSubmit(_("Import Selected Key"),'loadkey','','','','',true,true);
        } else {
            // if we didn't get an array, $foundkeys should have an error string
            echo codeHTML($foundkeys);
	};
	echo '</td></tr>'."\n";
        echo "</form>";
        //echo ob_get_contents();
        //ob_end_clean();
   };
}; //end search

if ($keyID) {
	$keyserver = $_POST['keyserver'];
	gpg_page_title( _("Import Key"));
    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">';
	echo codeHTML(_("Importing key with KeyID")).': &nbsp;'.$keyID;
	$return = gpg_recv_key($keyID,$debug,$keyserver);
    echo '</td></tr>';
    echo '<tr valign="top"><td width="100%" height="1%" class="nav" valign="top">';
	echo codeHTML($return);
    echo '</td></tr>';
}; //end import key

/**
 *
 * $Log: keyserver.mod,v $
 * Revision 1.21  2003/12/30 19:05:16  ke
 * -changed single to double quotes for translation purposes
 *
 * Revision 1.20  2003/12/29 23:54:16  brian
 * localized strings discovered by Alex Lemaresquier during French translation
 *
 * Revision 1.19  2003/11/04 21:41:01  brian
 * change to use SM_PATH
 *
 * Revision 1.18  2003/11/01 21:47:00  brian
 * Multiple Changes:
 * - removed $msg strings and gpg_Makepage functionality
 * - fixed multiple small bugs
 * - localized remaining strings
 * - improved formatting
 *
 * Revision 1.17  2003/10/11 20:32:45  brian
 * check for error string in return from gpg_keyserver_findkey fn
 * Bug 80
 *
 * Revision 1.16  2003/07/01 06:21:46  vermette
 * adding escape routes to options suite.  The previous 'back' link now only appears if requested (new arg to makePage).  This isn't done by any means, but at most it's as broken as it was, so it's an improvement.
 *
 * Revision 1.15  2003/06/27 21:18:22  brian
 * move keyserver extract to top of file so it will actually work
 *
 * Revision 1.14  2003/04/07 22:21:59  brian
 * modified files to not use extract $_POST
 * Bug 5
 *
 * Revision 1.13  2003/04/02 20:48:39  brian
 * fixed spelling errors using aspell
 * TODO - check grammer and sentence structure manually
 * Bug 18
 *
 * Revision 1.12  2003/04/01 18:04:06  brian
 * fixed includes to reflect different calling directories
 *
 * Revision 1.11  2003/03/12 22:14:12  tyler
 * - default keyserver now only used to pre-pick your preferred keyserver
 * - you can pick a different keyserver to search on the fly
 *
 * Revision 1.10  2003/03/12 21:59:26  tyler
 * - Fixed a bug where you could not have a default keyserver set yet still
 * - be able to search, but results would be unusable on later screens for
 * - input. Now you can search without a default and still import.
 *
 * Revision 1.9  2003/03/12 02:01:18  tyler
 * - $key looks to be set as a global so changed it to $keyID
 *
 * Revision 1.8  2003/03/11 23:29:15  tyler
 * - modified to use the new broken out *_function.php files
 *
 * Revision 1.7  2003/03/07 15:54:40  brian
 * Removed enctype=multipart/form-data - not needed for this form
 *
 * Revision 1.6  2003/03/07 00:10:39  brian
 * Removed superfluous includes.
 *
 * Revision 1.5  2002/12/10 21:52:27  vinay
 * now can fetch keys from keyservers
 *
 * Revision 1.4  2002/12/10 14:33:37  brian
 * edited to use global \$debug, rather than a local code
 *
 * Revision 1.3  2002/12/09 03:48:59  vinay
 * added support for system preferences
 *
 * Revision 1.2  2002/12/06 22:32:13  vinay
 * initial revision +1
 *
 * Revision 1.1  2002/12/06 22:30:20  vinay
 * initial revision
 *
 *
 *
 */

?>
