<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
 * passpop.mod
 *-----------
 * GPG plugin passphrase submission module file,
 *
 * Copyright (c) 2002-2003 Braverock Ventures
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * @author Aaron van Meerten
 *
 * $Id: passpop.mod,v 1.16 2003/11/18 14:45:48 ke Exp $
 */
if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else { echo "unable to define SM_PATH in gpg_pop_init.php, exiting abnormally"; }
}

require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'functions/forms.php');

global $color, $onload;
global $username, $pserr;

$use_signing_key_id = getPref ($data_dir, $username, 'use_signing_key_id');

$no_signing_passwd = getPref ($data_dir, $username, 'no_signing_passwd');

sqgetGlobalVar('username',  $username,      SQ_SESSION);
sqgetGlobalVar('psaction', $psaction);
sqgetGlobalVar('addbasepath',$addbasepath);
sqgetGlobalVar('HTTP_USER_AGENT', $HTTP_USER_AGENT, SQ_SERVER);

echo '<script language=JavaScript src=';
   echo SM_PATH."/plugins/gpg/js/gpgsubmitpass.js";
echo '></script>';

switch($psaction) {
    case 'sign':
        $title=_("GPG Signing Initiating");
        if (gpg_is_passphrase_cacheable()) {
            $onclick='';
        } else {
            $onclick="gpg_nocache_sign_click(this)";
        }
        break;
    case 'signdraft':
        $title=_("GPG Draft Signing Initiating");
        if (gpg_is_passphrase_cacheable()) {
            $onclick='';
        } else {
            $onclick="gpg_nocache_signdraft_click(this)";
        }
        break;
    case 'encrsign':
        $title=_("GPG Encrypt and Sign Initiating");
        if (gpg_is_passphrase_cacheable()) {
            $onclick='';
        } else {
            $onclick="gpg_encrsign_submit()";
        }
        break;
    case 'decrypt':
        $title=_("GPG Decryption Initiating");
        $onclick="gpg_decrypt_submit()";
        break;
    case 'delete':
        $title=_("Confirm Delete Key");
        $onclick="gpg_delete_submit()";
        break;
    case 'deletepair':
        $title=_("Confirm Delete Keypair");
        $onclick="gpg_delete_pair_submit()";
        break;
}

if ($title) {
    echo '<tr valign="top"><td width="100%" height="1%" class="optionlink" align="center" valign="top">';
    echo codeHTML($title);
    echo '</td></tr>';
}

if ($onclick != '') { $onclick .= "; return false;"; }

echo addForm('#', 'POST', 'main','multipart/form-data', $onclick);

if (gpg_is_passphrase_cacheable() and $psaction!='decrypt' and $psaction!='delete' and $pasaction!='deletepair') {
    echo addHidden('MOD', 'cachepass');
}

if ($addbasepath) { echo addHidden('addbasepath', $addbasepath); }

if ($no_signing_passwd != 'true') {

    if (gpg_https_connection ()) {
	echo addHidden('psaction', $psaction);
	echo $hiddenvars;
	if ($pserr) {
	    echo '<tr valign="top"><td width="100%" height="1%" class="error" align="center" valign="top">';
	    echo codeHTML($pserr);
	    echo '</td></tr>';
	}
	echo '<tr valign="top"><td width="100%" height="1%" class="nav" align="center" valign="top">';
	if (strstr($HTTP_USER_AGENT, 'MSIE')!=false) {
	    echo codeHTML(_("Enter Passphrase")).':<BR>'. addPwField('passphrase','','onkeydown="if (event.keyCode == 13) { '.$onclick.' }"');
	} else {
	    echo codeHTML(_("Enter Passphrase")).':<BR>'. addPwField('passphrase','','');
	}
	echo '</td></tr>';
	echo '<tr valign="top"><td width="100%" height="1%" class="nav" align="center" valign="top">';
	    echo addButton(_("Cancel"), '', '','window.close();','','',1,1).'&nbsp;';
	    echo addSubmit(_("Submit"), '', '',$onclick,'','',1,1);
	echo '</td></tr>';
    } else {
	echo '<tr valign="top"><td width="100%" height="1%" class="nav" align="center" valign="top">';
	echo codeHTML(_("You are not connected using a secure connection.")).'<br>'.codeHTML(_("Signing functions not allowed from an insecure connection."));
	echo '</td></tr>';
	echo '<tr valign="top"><td width="100%" height="1%" class="nav" align="center" valign="top">';
	echo addButton(_("Cancel"), '', '','window.close();','','',1,1);
	echo '</td></tr>';
    }
}

echo '</form>';
echo "<script language=JavaScript>\n<!--\n\nvar addbasepath='$addbasepath';\n\n";
echo "\n//-->\n</script>\n";

/*
 * $Log: passpop.mod,v $
 * Revision 1.16  2003/11/18 14:45:48  ke
 * -removed hardcoded debug
 *
 * Revision 1.15  2003/11/17 23:27:01  ke
 * -changed no_signing_pass check to != 'true' instead of =='false'
 * -makes no_signing_pass option no longer needed in preferences
 * bug 110
 *
 * Revision 1.14  2003/11/12 17:36:58  ke
 * -added code to allow submission correctly when enter key is pressed
 * bug 108
 *
 * Revision 1.13  2003/11/04 21:03:43  ke
 * -moved body tag into this file, out of gpg_pop_init
 *
 * Revision 1.12  2003/11/03 18:40:35  ke
 * -fixed passpop to allow gpgdecrypt to cache its own passphrase
 *
 * Revision 1.11  2003/11/03 17:34:03  ke
 * -changed to use abstracted functions for checking cached passphrase
 * bug 66
 *
 * Revision 1.10  2003/11/03 15:52:37  ke
 * -added titling HTML to this module, removed from gpg_pop_init
 *
 * Revision 1.9  2003/11/01 21:48:05  brian
 * Multiple Changes:
 * - removed $msg strings and gpg_Makepage functionality
 * - localized remaining strings
 * @todo fix page header for passphrase pop-up
 *
 * Revision 1.8  2003/10/30 21:12:56  brian
 * fixed problems apparent in the xgettext index
 * Bug 35
 *
 * Revision 1.7  2003/10/30 21:10:57  brian
 * fixed problems apparent in the xgettext index
 * Bug 35
 *
 * Revision 1.6  2003/10/30 20:28:28  ke
 * -changed single to double quotes in internationalized strings
 * Bug 35
 *
 * Revision 1.5  2003/10/27 19:33:30  ke
 * -added addbasepath javascript and hidden variable to allow submission to proper place
 * bug 82
 *
 * Revision 1.4  2003/10/11 21:35:48  ke
 * -Added signdraft case for running save draft javascript
 *
 * Revision 1.3  2003/10/10 19:01:46  ke
 * -Added ability to be called from keyview for deletion of keys
 *
 * Revision 1.2  2003/10/07 23:58:38  ke
 * -Changed dialog prompts depending on where it's called from
 *
 * Revision 1.1  2003/10/07 22:19:37  ke
 * -consolidated passphrase popup dialog
 * -created from sign_init.mod
 * -can be called from decrypt, encrypt&sign now, sign on send
 *
 * Revision 1.21  2003/10/07 19:25:03  ke
 * -Added error message option above the passphrase textbox
 *
 * Revision 1.20  2003/09/30 00:34:49  ke
 * -Internationalized strings in sign_init.mod
 * bug 35
 *
 * Revision 1.19  2003/09/29 16:12:26  ke
 * -Removed sign_functions includes (no longer needed in this module)
 * -Added preference check to change behavior if user is not caching passphrase
 *
 * Revision 1.18  2003/09/26 11:02:58  brian
 * added back in log comments that were removed
 *  by rolling back, for completeness
 *
 * Revision 1.17  2003/09/26 01:57:47  ke
 * - Rolled sign_init.mod back interface changes,
 *   turned back into a popup window.
 *   Still need to handle non-caching options
 * bug 40
 *
 * Revision 1.16  2003/09/24 18:42:16  ke
 * -added initial hooks to handle attachments in sign_init, mainly for debugging purposes
 *
 * Revision 1.15  2003/09/23 22:49:55  ke
 * - Set submission for encrypt&sign back to compose.php
 * - Places body text in signbody session variable
 * Bug 55
 *
 * Revision 1.14  2003/09/18 22:23:32  ke
 * -changed sign_init module to take submission of compose.php page
 * -added hidden variables to pass through submitted variables
 * -added submission to compose.php (for encrypt&sign) or gpgsign module (for sign only)
 * Bug 55
 *
 * Revision 1.13  2003/04/07 17:42:31  brian
 * added https test for signing with passphrase
 * bug 7 fixed
 *
 * Revision 1.12  2003/04/02 20:48:39  brian
 * fixed spelling errors using aspell
 * TODO - check grammer and sentence structure manually
 * Bug 18
 *
 * Revision 1.11  2003/04/01 17:45:02  brian
 * updated to remove the onsubmitp'return false' in the form tag
 *
 * Revision 1.10  2003/04/01 07:11:42  brian
 * fixed includes to reflect different calling directories
 *
 * Revision 1.9  2003/03/31 14:12:00  brian
 * added require_once statement to require signing functions file.
 * change needed to use generalized pop-up window function
 *
 * Revision 1.8  2003/03/28 13:29:34  brian
 * - changed functions from gpgsignsubmit and gpgsigninit to
 *   gpg_pop_init and gpg_pop_submit
 *   to better abstract them for use in decryption
 * - manually added header block and Log: entries to file
 * Bug 8
 *
 * Revision : 1.7 2003/3/13 20:29:25 'tyler'
 * - disabled the use of 'enter' or 'return' when entering passphrase. This
 * - follows the coding style of Squirrelspell and ensures an onclick()
 *
 * Revision : 1.6 2003/3/13 20:7:18 'tyler'
 * - building the <body> tag for onload() needs to be done in the makeWindow function otherwise we get two body tags and the onload() version doesnt work
 *
 * Revision : 1.5 2003/3/13 15:41:11 'tyler'
 * - onload() is for auto_sign...onclick() is for no auto_sign
 *
 * Revision : 1.4 2003/3/13 4:6:6 'brian'
 * - modified to correctly accept passphrase for message signing
 * - added checks for using the signing feature and
 *   needing passphrase for secret key
 *
 * Revision : 1.3 2003/3/12 4:53:53 'tyler'
 * - if autosign preference is set true then don't ask for passphrase
 *
 * Revision : 1.2 2003/3/11 22:0:40 'tyler'
 * - initial work to accept passphrase in the pop-up window
 *
 * Revision : 1.1 2003/3/11 4:10:34 'tyler'
 * - Main window we pop to grab the passphrase before signing
 */
?>
