<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * mail_fetch/fetch.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Fetch code.
 *
 * $Id: fetch.php,v 1.3 2004/02/25 15:02:09 marco Exp $
 */

define('SM_PATH','../../');

require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'plugins/mail_fetch/class.POP3.php');
require_once(SM_PATH . 'plugins/mail_fetch/functions.php' );
require_once(SM_PATH . 'functions/html.php' );
require_once(SM_PATH . 'functions/forms.php');
require_once(SM_PATH . 'functions/global.php');

/* globals */
sqgetGlobalVar('username',   $username,   SQ_SESSION);
sqgetGlobalVar('key',        $key,        SQ_COOKIE);
sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);
sqgetGlobalVar('delimiter',  $delimiter,  SQ_SESSION);
/* end globals */

global $demo_version;

function Mail_Fetch_Status($msg) {
    echo '<tr>
            <td align="left" width="100%" class="nav">
                '.codeHTML( $msg ).'
            </td>
        </tr>'."\n";
    flush();
}

$mailfetch_server_number = getPref($data_dir, $username, "mailfetch_server_number");
if (!isset($mailfetch_server_number)) $mailfetch_server_number=0;
$mailfetch_cypher = getPref($data_dir, $username, "mailfetch_cypher");
if ($mailfetch_server_number<1) $mailfetch_server_number=0;
for ($i=0;$i<$mailfetch_server_number;$i++) {
    $mailfetch_server_[$i] = getPref($data_dir, $username, "mailfetch_server_$i");
    $mailfetch_port_[$i] = getPref($data_dir, $username, "mailfetch_port_$i");
    $mailfetch_alias_[$i] = getPref($data_dir, $username, "mailfetch_alias_$i");
    $mailfetch_user_[$i] = getPref($data_dir, $username, "mailfetch_user_$i");
    $mailfetch_pass_[$i] = getPref($data_dir, $username, "mailfetch_pass_$i");
    $mailfetch_lmos_[$i] = getPref($data_dir, $username, "mailfetch_lmos_$i");
    $mailfetch_login_[$i] = getPref($data_dir, $username, "mailfetch_login_$i");
    $mailfetch_uidl_[$i] = getPref($data_dir, $username, "mailfetch_uidl_$i");
    $mailfetch_subfolder_[$i] = getPref($data_dir, $username, "mailfetch_subfolder_$i");
    if($mailfetch_subfolder_[$i] == '') {
        $mailfetch_subfolder_[$i] == 'INBOX';
    }
    if( $mailfetch_cypher == 'on' ) {
        $mailfetch_pass_[$i] = decrypt( $mailfetch_pass_[$i] );
    }
}

//************** Start HTML *****************************************// 

displayHtmlHeader(_("Fetch Mail")); 

echo '<body onload="self.focus();">';

// PAGINA INIZIALE    
// get $server_to_fetch from globals, if not set display a choice to the user
if (! sqgetGlobalVar('server_to_fetch', $server_to_fetch, SQ_POST) ) {
echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
    echo '<tr height="20%">
            <td align="center" width="100%" class="optionlink">
                '.codeHTML(_("Remote POP server Fetching Mail")).'
            </td>
	</tr>'."\n";
    echo '<tr valign="top" height="80%"><td width="100%" valign="top">';
	echo addForm($PHP_SELF, 'POST', 'ffetch','','','','_self'); 
	echo '<table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
	    echo '<tr>  
            	    <td align="left" width="30%" class="nav">
                	'.codeHTML(_("Select Server")) . ':
            	    </td>
            	    <td align="left" class="nav">';
			$new_option = array();
			$new_option['all'] = _("All");
    			for ($i=0;$i<$mailfetch_server_number;$i++) {
			    $new_option[$i] = ($mailfetch_alias_[$i]=='') ? $mailfetch_server_[$i] : $mailfetch_alias_[$i];
    			}
			echo addSelect('server_to_fetch', $new_option, 'all', TRUE);
		echo '</td>
    	    </tr>'."\n";
    	    //if password not set, ask for it
    	    for ($i=0;$i<$mailfetch_server_number;$i++) {
        	if ($mailfetch_pass_[$i]=='') {
		    echo '<tr>  
            		<td align="left" width="30%" class="nav">
                	    '.codeHTML(_("Password for")) .'&nbsp;'. codeHTML((($mailfetch_alias_[$i]=='')?$mailfetch_server_[$i]:$mailfetch_alias_[$i])) .':
            		</td>
            		<td align="left" class="nav">';
			    echo addPwField('pass_'.$i , '');
			echo '</td>
        	    </tr>'."\n";
		}
	    }
	    if ($demo_version) {
		echo '<tr valign="top">
        	    <td align="center" valign="middle" width="100%" class="nav" colspan=2>';
			echo addHidden('submit_mailfetch',_("Fetch Mail"));
			echo addButton(_("Fetch Mail"), '','','alert("'.jsspecialchars(_("This is a DEMO version. Is not possible to fetch mails from other servers.")).'"); return false;','ffetch','','1','1');
        	echo '</td>
    		</tr>';
	    } else {
		echo '<tr valign="top">
        	    <td align="center" valign="middle" width="100%" class="nav" colspan=2>';
			echo addHidden('submit_mailfetch',_("Fetch Mail"));
			echo addButton(_("Fetch Mail"), '','','','ffetch');
        	echo '</td>
    		</tr>';
	    }
	echo "</form>\n";
	echo '</table></td></tr>';
        exit();
    }

echo '<table class="border" width="100%" align="center" valign="top" cellpadding="0" cellspacing="2" border="0">'."\n";
    echo '<tr>
            <td align="center" width="100%" class="optionlink">
                '.codeHTML(_("Remote POP server Fetching Mail")).'
            </td>
	</tr>'."\n";
    // AZIONI
    if ( $server_to_fetch == 'all' ) {
        $i_start = 0;
        $i_stop = $mailfetch_server_number;
    } else {
        $i_start = $server_to_fetch;
        $i_stop = $i_start+1;
    }
    echo '<tr>
            <td align="left" width="100%" class="nav">
		&nbsp;
            </td>
	</tr>'."\n";

    for ($i_loop=$i_start;$i_loop<$i_stop;$i_loop++) {
        $mailfetch_server=$mailfetch_server_[$i_loop];
        $mailfetch_port=$mailfetch_port_[$i_loop];
        $mailfetch_user=$mailfetch_user_[$i_loop];
        if ($mailfetch_pass_[$i_loop] == '') {
            sqgetGlobalVar("pass_$i_loop", $mailfetch_pass, SQ_POST);
        } else {
            $mailfetch_pass = $mailfetch_pass_[$i_loop];
        }
        $mailfetch_lmos=$mailfetch_lmos_[$i_loop];
        $mailfetch_login=$mailfetch_login_[$i_loop];
        $mailfetch_uidl=$mailfetch_uidl_[$i_loop];
        $mailfetch_subfolder=$mailfetch_subfolder_[$i_loop];

        $pop3 = new POP3($mailfetch_server, 60);

	echo '<tr>
            <td align="left" width="100%" class="optionlink">
                '.codeHTML(_("Fetching from")).'&nbsp;'. codeHTML((($mailfetch_alias_[$i_loop] == '')?$mailfetch_server:$mailfetch_alias_[$i_loop])).'
            </td>
	</tr>'."\n";

        flush();

        if (!$pop3->connect($mailfetch_server,$mailfetch_port)) {
            Mail_Fetch_Status( _("Oops") .", ". $pop3->ERROR );
            continue;
        }

        Mail_Fetch_Status(_("Opening IMAP server"));
        $imap_stream = sqimap_login($username, $key, $imapServerAddress, $imapPort, 10);

        Mail_Fetch_Status(_("Opening POP server"));
        $Count = $pop3->login($mailfetch_user, $mailfetch_pass);
        if (($Count == false || $Count == -1) && $pop3->ERROR != '') {
            Mail_Fetch_Status(_("Login Failed:") . ' ' . $pop3->ERROR );
            continue;
        }

        //   register_shutdown_function($pop3->quit());

        $msglist = $pop3->uidl();

        $i = 1;
        for ($j = 1; $j < sizeof($msglist); $j++) {
           if ($msglist["$j"] == $mailfetch_uidl) {
                $i = $j+1;
                break;
           }
        }

        if ($Count < $i) {
            Mail_Fetch_Status(_("Login OK: No new messages"));
            $pop3->quit();
            continue;
        }
        if ($Count == 0) {
            Mail_Fetch_Status(_("Login OK: Inbox EMPTY"));
            $pop3->quit();
            continue;
        } else {
            $newmsgcount = $Count - $i + 1;
            Mail_Fetch_Status(_("Login OK: Inbox contains [") . $newmsgcount . _("] messages"));
        }

        Mail_Fetch_Status(_("Fetching UIDL..."));
        // Faster to get them all at once
        $mailfetch_uidl = $pop3->uidl();

        if (! is_array($mailfetch_uidl) && $mailfetch_lmos == 'on')
            Mail_Fetch_Status(_("Server does not support UIDL."));

        if ($mailfetch_lmos == 'on') {
            Mail_Fetch_Status(_("Leaving Mail on Server..."));
        } else {
            Mail_Fetch_Status(_("Deleting messages from server..."));
        }

        for (; $i <= $Count; $i++) {
            Mail_Fetch_Status(_("Fetching message") ." ". "$i" );
	    if (!ini_get('safe_mode'))
                set_time_limit(20); // 20 seconds per message max
            $Message = "";
            $MessArray = $pop3->get($i);

            while ( (!$MessArray) or (gettype($MessArray) != "array")) {
                 Mail_Fetch_Status(_("Oops") .", ". $pop3->ERROR );
                 // re-connect pop3
                 Mail_Fetch_Status(_("Server error...Disconnect"));
                 $pop3->quit();
                 Mail_Fetch_Status(_("Reconnect from dead connection"));
                 if (!$pop3->connect($mailfetch_server)) {
                     Mail_Fetch_Status(_("Oops") .", ". $pop3->ERROR );
                     Mail_Fetch_Status(_("Saving UIDL"));
                     setPref($data_dir,$username,"mailfetch_uidl_$i_loop", $mailfetch_uidl[$i-1]);

                     continue;
                 }
                 $Count = $pop3->login($mailfetch_user, $mailfetch_pass);
                 if (($Count == false || $Count == -1) && $pop3->ERROR != '') {
                     Mail_Fetch_Status(_("Login Failed:") . ' ' . $pop3->ERROR );
                     Mail_Fetch_Status(_("Saving UIDL"));
                     setPref($data_dir,$username,"mailfetch_uidl_$i_loop", $mailfetch_uidl[$i-1]);

                     continue;
                 }
                 Mail_Fetch_Status(_("Refetching message") ." ". "$i" );
                 $MessArray = $pop3->get($i);

            } // end while

            while (list($lineNum, $line) = each ($MessArray)) {
                 $Message .= $line;
            }

            fputs($imap_stream, "A3$i APPEND \"$mailfetch_subfolder\" {" . strlen($Message) . "}\r\n");
            $Line = fgets($imap_stream, 1024);
            if (substr($Line, 0, 1) == '+') {
                fputs($imap_stream, $Message);
                fputs($imap_stream, "\r\n");
                sqimap_read_data($imap_stream, "A3$i", false, $response, $message);
                if ( $response <> 'OK' ) {
                    Mail_Fetch_Status(_("Error Appending Message!")." ".$message );
                    Mail_Fetch_Status(_("Closing POP"));
                    $pop3->quit();
                    Mail_Fetch_Status(_("Logging out from IMAP"));
                    sqimap_logout($imap_stream);

                    Mail_Fetch_Status(_("Saving UIDL"));
                    setPref($data_dir,$username,"mailfetch_uidl_$i_loop", $mailfetch_uidl[$i-1]);
                    exit;
                } else {
                    Mail_Fetch_Status(_("Message appended to mailbox"));
                }

                if ($mailfetch_lmos != 'on') {
                   if( $pop3->delete($i) ) {
                        Mail_Fetch_Status(_("Message") ." ". $i . " ". _("deleted from Remote Server!"));
                   } else {
                        Mail_Fetch_Status(_("Delete failed:") . $pop3->ERROR );
                   }
                }
            } else {
                echo "$Line";
                Mail_Fetch_Status(_("Error Appending Message!"));
                Mail_Fetch_Status(_("Closing POP"));
                $pop3->quit();
                Mail_Fetch_Status(_("Logging out from IMAP"));
                sqimap_logout($imap_stream);

                // not gurantee corect!
                Mail_Fetch_Status(_("Saving UIDL"));
                setPref($data_dir,$username,"mailfetch_uidl_$i_loop", $mailfetch_uidl[$i-1]);
                exit;
            }
        }

        Mail_Fetch_Status(_("Closing POP"));
        $pop3->quit();
        Mail_Fetch_Status(_("Logging out from IMAP"));
        sqimap_logout($imap_stream);
        if (is_array($mailfetch_uidl)) {
            Mail_Fetch_Status(_("Saving UIDL"));
            setPref($data_dir,$username,"mailfetch_uidl_$i_loop", array_pop($mailfetch_uidl));
        }
        Mail_Fetch_Status(_("Done"));
    }
    echo '<tr>
            <td align="left" width="100%" class="nav">
		&nbsp;
            </td>
	</tr>'."\n";
?>
</table>
</body>
</html>
