<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

define('SM_PATH','../');    
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

global $address_book_list_count;

sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION );  

sqgetGlobalVar('where', $where, SQ_GET);
if (!$where) { sqgetGlobalVar('where', $where, SQ_POST); }
if (!$where) { $where = "A"; }

sqgetGlobalVar('nsearch', $nsearch, SQ_GET);
if (!$nsearch) { sqgetGlobalVar('nsearch', $nsearch, SQ_POST); }

sqgetGlobalVar('filter_group', $filter_group, SQ_GET);
if (!$filter_group) { sqgetGlobalVar('filter_group', $filter_group, SQ_POST); }
if (!$filter_group) { $filter_group = "ALL"; }

$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];

if($abook->localbackend == 0) {
    plain_error_message(
        codeHTML(_("No personal address book is defined. Contact administrator.")),
        $color);
    exit();
}

if ($filter_group && $filter_group != "ALL") {
    list($ebackend, $enick) = explode(';', $filter_group);
    $data = $gabook->lookup_id($enick, $ebackend);
    $private_contacts = array();
    $public_contacts = array();
    if ($data['group_list_private']) {
        $private_contacts = $abook->lookup_group_id($data['group_list_private'], 1, 2, $where);
    }
    if ($data['group_list_public']) {
        $public_contacts = $abook->lookup_group_id($data['group_list_public'], 2, 2, $where);
    }
    $alist = array_merge($public_contacts,$private_contacts);
    // annullo altre ricerche
    $nsearch = "";
} else if ($where == "groups") {
    $alist = $gabook->list_addr(-1,1);
    if(!is_array($alist)) {
	plain_error_message(codeHTML($gabook->error), $color);
	exit;
    }
} else {
    $alist = $abook->list_addr(-1,1,$where,$nsearch);
    if(!is_array($alist)) {
	plain_error_message(codeHTML($abook->error), $color);
	exit;
    }
}

/* Sort array by the key "name" */
function alistcmpoverlook($a,$b) {
    return (strtolower($a['Nominativo']) > strtolower($b['Nominativo'])) ? 1 : -1;
}
function alistcmpoverlookgroup($a,$b) {
    return (strtolower($a['group_name']) > strtolower($b['group_name'])) ? 1 : -1;
}

if ($where == "groups") {
    $jswhere = 2;
    usort($alist,'alistcmpoverlookgroup');
} else {
    $jswhere = 1;
    usort($alist,'alistcmpoverlook');
}

displayHtmlHeader( '');

echo "\n".'<script language="JavaScript" type="text/javascript">
	var msg1 = "'.jsspecialchars(_("Please, select a contact!")).'";
	var where = '.$jswhere.';
	</script>'."\n";

echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/addressbook_popup_iframe.js"></script>'."\n";

echo "\n<body onload='self.focus();'>\n";
    echo '<table width="100%" height="100%" border=0 cellpadding=2 cellspacing=0 valign="top" class="nav" align="left">';
    echo addForm($base_uri.'src/addressbook_popup.php', 'POST', 'iframef');
    echo '<tr valign="top"><td valign="top" align="center" nowrap=1 class="nav" width="100%">';
	$new_option = array();
	while(list($undef,$row) = each($alist)) {   
	    if ($where == "groups") {
		if ($row['source'] == _("Global group address book")) {
		    $new_option[$row['group_id'].';[['.$row['group_name'].']]'] = array( 'value' => '[['.$row['group_name'].']]', 'class' => 'globalcontact');
		} else {
		    $new_option[$row['group_id'].';['.$row['group_name'].']'] = array( 'value' => '['.$row['group_name'].']', 'class' => 'privatecontact');
		}
	    } else {	
		if ($row['source'] == _("Global address book")) {
		    $new_option[ $row['idrub'].';'.$row['Nominativo'].' <'.$row['Email'].'>' ] = array ( 'value' => $row['Nominativo'], 'class' => 'globalcontact'); 
		} else {
		    $new_option[$row['idrub'].';'.$row['Nominativo'].' <'.$row['Email'].'>' ] = array ( 'value' => $row['Nominativo'], 'class' => 'privatecontact'); 
		}
	    }
	}
	echo addSelect('contact_list', $new_option, '', TRUE, 'multiple=1 style="width:100%;height:100%;"');

    echo '</td></tr>';
    echo '<tr><td align="center" nowrap=1 class="nav" valign="middle" width="100%" height="1%">';
	echo addButton(_("View Info"),'','','ViewInfo();','','',1,1);
    echo '</td></tr>';
      echo '</form></table>';
    echo "</body></html>\n";
?>