<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * compose.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This code sends a mail.
 *
 * There are 4 modes of operation:
 *    - Start new mail
 *    - Add an attachment
 *    - Send mail
 *    - Save As Draft
 *
 * $Id: compose.php,v 1.12 2004/06/01 09:59:58 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/imap_mailbox.php');
require_once(SM_PATH . 'functions/date.php');
require_once(SM_PATH . 'functions/mime.php');
require_once(SM_PATH . 'functions/plugin.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'class/deliver/Deliver.class.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/forms.php');

# mi serve sia post che get
sqgetGlobalVar('use_local_htmlarea',$use_local_htmlarea, SQ_GET);
sqgetGlobalVar('use_hidden_htmlarea',$use_hidden_htmlarea, SQ_POST);
sqgetGlobalVar('HTTP_USER_AGENT', $HTTP_USER_AGENT, SQ_SERVER);

if ($use_local_htmlarea) {
    if ($use_local_htmlarea == "yes") { $use_htmlarea = 1; }
    else if ($use_local_htmlarea == "no") { $use_htmlarea = 0; }
}

if (preg_match('/Konqueror/i', $HTTP_USER_AGENT)) { $use_htmlarea = 0; }

if ($use_htmlarea) { require_once(SM_PATH . 'FCKeditor/fckeditor.php'); }

/* --------------------- Get globals ------------------------------------- */
/** COOKIE VARS */
sqgetGlobalVar('key',       $key,           SQ_COOKIE);

/** SESSION VARS */
sqgetGlobalVar('username',  $username,      SQ_SESSION);
sqgetGlobalVar('onetimepad',$onetimepad,    SQ_SESSION);
sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);

sqgetGlobalVar('composesession',    $composesession,    SQ_SESSION);
sqgetGlobalVar('compose_messages',  $compose_messages,  SQ_SESSION);

/** SESSION/POST/GET VARS */
sqgetGlobalVar('smaction',$action);
sqgetGlobalVar('session',$session);
sqgetGlobalVar('mailbox',$mailbox);
sqgetGlobalVar('identity',$identity);
sqgetGlobalVar('send_to',$send_to);
sqgetGlobalVar('send_to_cc',$send_to_cc);
sqgetGlobalVar('send_to_bcc',$send_to_bcc);
sqgetGlobalVar('subject',$subject);
sqgetGlobalVar('bodymsg',$body);
sqgetGlobalVar('mailprio',$mailprio);
sqgetGlobalVar('request_mdn',$request_mdn);
sqgetGlobalVar('request_dr',$request_dr);
sqgetGlobalVar('mail_sent',$mail_sent);
sqgetGlobalVar('passed_id',$passed_id);
sqgetGlobalVar('passed_ent_id',$passed_ent_id);

sqgetGlobalVar('send',$send);

sqgetGlobalVar('attach',$attach);

sqgetGlobalVar('draft',$draft);
sqgetGlobalVar('draft_id',$draft_id);
sqgetGlobalVar('ent_num',$ent_num);
sqgetGlobalVar('saved_draft',$saved_draft);
sqgetGlobalVar('delete_draft',$delete_draft);
sqgetGlobalVar('startMessage',$startMessage);
sqgetGlobalVar('name_newsletter',$name_newsletter);
sqgetGlobalVar('newsletter',$newsletter);

sqgetGlobalVar('request_mdn',$request_mdn);
sqgetGlobalVar('request_dr',$request_dr);
sqgetGlobalVar('sign_on_send',$sign_on_send);
sqgetGlobalVar('encrypt_on_send',$encrypt_on_send);

/** POST VARS */
sqgetGlobalVar('from_htmladdr_search',  $from_htmladdr_search,  SQ_POST);
sqgetGlobalVar('send_to_search',        $send_to_search,        SQ_POST);
sqgetGlobalVar('do_delete',             $do_delete,             SQ_POST);
sqgetGlobalVar('delete',                $delete,                SQ_POST);
sqgetGlobalVar('restoremessages',       $restoremessages,       SQ_POST);

global $sent_folder;
sqgetGlobalVar('sent_folder',           $mysentfolder,          SQ_POST);
if ($mysentfolder) { $sent_folder = $mysentfolder; }

/** GET VARS */
sqgetGlobalVar('attachedmessages', $attachedmessages, SQ_GET);

/* Location (For HTTP 1.1 Header("Location: ...") redirects) */
$location = get_location();

global $custom_css, $demo_version;

/* --------------------- Specific Functions ------------------------------ */

function replyAllString($header) {
   global $include_self_reply_all, $username, $data_dir;
   $excl_ar = array();
   /**
    * 1) Remove the addresses we'll be sending the message 'to'
    */
   $url_replytoall_avoid_addrs = '';
   if (isset($header->replyto)) {
      $excl_ar = $header->getAddr_a('replyto');
   }
   /**
    * 2) Remove our identities from the CC list (they still can be in the
    * TO list) only if $include_self_reply_all is turned off
    */
   if (!$include_self_reply_all) {
       $email_address = strtolower(trim(getPref($data_dir, $username, 'email_address')));
       $excl_ar[$email_address] = '';
       $idents = getPref($data_dir, $username, 'identities');
       if ($idents != '' && $idents > 1) {
              $first_id = false;
          for ($i = 1; $i < $idents; $i ++) {
             $cur_email_address = getPref($data_dir, $username,
                                         'email_address' . $i);
             $cur_email_address = strtolower(trim($cur_email_address));
             $excl_ar[$cur_email_address] = '';
         }
       }
   }

   /**
    * 3) get the addresses.
    */
   $url_replytoall_ar = $header->getAddr_a(array('to','cc'), $excl_ar);

   /**
    * 4) generate the string.
    */
   $url_replytoallcc = '';
   foreach( $url_replytoall_ar as $email => $personal) {
      if ($personal) {
         // if personal name contains address separator then surround
         // the personal name with double quotes.
         if (strpos($personal,',') !== false) {
             $personal = '"'.$personal.'"';
         }
         $url_replytoallcc .= ", $personal <$email>";
      } else {
         $url_replytoallcc .= ', '. $email;
      }
   }
   $url_replytoallcc = substr($url_replytoallcc,2);

   return $url_replytoallcc;
}

function getReplyCitation($orig_from, $orig_date) {
    global $reply_citation_style, $reply_citation_start, $reply_citation_end;
    $orig_from = decodeHeader($orig_from->getAddress(false),false,false);
    /* First, return an empty string when no citation style selected. */
    if (($reply_citation_style == '') || ($reply_citation_style == 'none')) {
        return '';
    }

    /* Make sure our final value isn't an empty string. */
    if ($orig_from == '') {
        return '';
    }

    /* Otherwise, try to select the desired citation style. */
    switch ($reply_citation_style) {
    case 'author_said':
        $start = '';
        $end   = ' ' . _("said") . ':';
        break;
    case 'quote_who':
        $start = '<' . _("quote") . ' ' . _("who") . '="';
        $end   = '">';
        break;
    case 'date_time_author':
        $start = 'On ' . getLongDateString($orig_date) . ', ';
        $end = ' ' . _("said") . ':';
        break;
    case 'user-defined':
        $start = $reply_citation_start .
         ($reply_citation_start == '' ? '' : ' ');
        $end   = $reply_citation_end;
        break;
    default:
        return '';
    }

    /* Build and return the citation string. */
    return ($start . $orig_from . $end . "\n");
}

function getforwardHeader($orig_header) {
    global $editor_size, $use_htmlarea;

   $display = array( _("Subject") => strlen(_("Subject")),
                     _("From")    => strlen(_("From")),
                     _("Date")    => strlen(_("Date")),
                     _("To")      => strlen(_("To")),
                     _("Cc")      => strlen(_("Cc")) );
   $maxsize = max($display);
   $indent = str_pad('',$maxsize+2);
   foreach($display as $key => $val) {
      $display[$key] = $key .': '. str_pad('', $maxsize - $val);
   }
   $from = decodeHeader($orig_header->getAddr_s('from',"\n$indent"),false,false);
   $from = str_replace('&nbsp;',' ',$from);
   $to = decodeHeader($orig_header->getAddr_s('to',"\n$indent"),false,false);
   $to = str_replace('&nbsp;',' ',$to);
   $subject = decodeHeader($orig_header->subject,false,false);
   $subject = str_replace('&nbsp;',' ',$subject);
   $bodyTop =  str_pad(' '._("Original Message").' ',$editor_size -2,'-',STR_PAD_BOTH) ."\n\n". 
	       $display[_("Subject")] . $subject . "\n" .
               $display[_("From")] . $from . "\n" .
               $display[_("Date")] . getLongDateString( $orig_header->date ). "\n" .
               $display[_("To")] . $to . "\n";
   if ($orig_header->cc != array() && $orig_header->cc !='') {
      $cc = decodeHeader($orig_header->getAddr_s('cc',"\n$indent"),false,false);
      $cc = str_replace('&nbsp;',' ',$cc);
     $bodyTop .= $display[_("Cc")] .$cc . "\n";
  }
  $bodyTop .= str_pad('', $editor_size -2 , '-') .
              "\n\n";
  if ($use_htmlarea) { $bodyTop = codeHTML($bodyTop); }
  return $bodyTop;
}

/* blatently copied/truncated/modified from the above function */
function compose_Header_overlook($mailbox) {
    global $delimiter, $hide_sm_attributions, $base_uri, $PHP_SELF, $use_htmlarea,
           $data_dir, $username, $compose_new_win, $arraysignature, $prefix_sig, $custom_css;

    sqgetGlobalVar('HTTP_USER_AGENT', $HTTP_USER_AGENT, SQ_SERVER);

    displayHtmlHeader (_("Compose"), '');
    echo '<script language="javascript">
	    var sendClicked=false;
            var draftClicked=false;
    	    var use_htmlarea = "'.$use_htmlarea.'";
	    var msgpriorityhigh = "'.jsspecialchars(_("The message has high priority")).'";
	    var msgprioritynormal = "'.jsspecialchars(_("The message has normal priority")).'";
	    var msgprioritylow = "'.jsspecialchars(_("The message has low priority")).'";
	    var msgnosignature = "'.jsspecialchars(_("No signature is defined")).'";
	    var msgnosenddemo = "'.jsspecialchars(_("This version is a DEMO! Is not possible to send e-mail.")).'";
	    var msgnoreceiver = "'.jsspecialchars(_("Please, insert the receiver of the message.")).'";
	    var msgnosubject = "'.jsspecialchars(_("This message does not have the subject. Send it anyway ?")).'";
	    var msgmodifyhtmlarea = "'.jsspecialchars(_("Modifying the input method destroys last changes. Continue anyway?")).'";
	    var msgwait = "'.jsspecialchars(_('Please wait...')).'";
	    var custom_css = "'.$custom_css.'";
	    var delimiter = "'.$delimiter.'";
	    var arraysignature = new Array();'."\n";
    for ($i=0;$i<count($arraysignature);$i++) {
	if ($use_htmlarea) { $arraysignature[$i] = jsspecialchars(codeHTML($arraysignature[$i])); } 
	else { $arraysignature[$i] = jsspecialchars($arraysignature[$i]); }
	echo  'arraysignature['.$i.']="'.$arraysignature[$i].'";'."\n";
    }
    if ($use_htmlarea) {
        echo 'var msg_add = "'.(isset($prefix_sig) && $prefix_sig==true? "-- <br>":'').'";'."\n";
    } else {
        echo 'var msg_add = "'.(isset($prefix_sig) && $prefix_sig==true? "-- \\n":'').'";'."\n";
    }
    echo '</script>'."\n";

    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/compose.js"></script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/new_window.js"></script>'."\n";    
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/tips.js"></script>';

    $onload = "onload=\"self.focus(); checkForm();\"";
    echo "<body $onload>\n\n";
}

function displayNavigationCompose($mailbox, $xtra='', $session=false) {
    global $hide_sm_attributions, $PHP_SELF, $icon_folder, $save_as_draft,
           $compose_new_win, $compose_width, $compose_height, $auto_expunge, $use_htmlarea,
           $attachemessages, $provider_name, $provider_uri, $base_uri, $arraysignature,
           $javascript_on, $mdn_user_support, $default_use_priority, $mailprio, 
	   $default_use_mdn, $request_mdn, $request_dr, $custom_css, $demo_version,$HTTP_USER_AGENT;

    sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION );
    sqgetGlobalVar('delimiter', $delimiter, SQ_SESSION );
    $safe_name = preg_replace("/[^0-9A-Za-z_]/", '_', $mailbox);

    $urlMailbox = urlencode($mailbox);
    echo '<table border=0 id="tbl" align="left" class="border" valign="top" width="100%" cellspacing="0" cellpadding="0">';
	echo '<tr>';
	    echo '<td align="left" height="100%" class="altaltnav" valign="top">';
		echo '<table border=0 valign="top" height="100%" align="left" cellspacing="0" cellpadding="0">';
		    echo '<tr height="100%">';
			echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="70" onclick="CheckSend('.$demo_version.');">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/mail_send.gif" name="img_send" title="'._("Send").'" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Send"));
			echo '</td>'."\n";
			if ($save_as_draft) {
			    echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="70" onclick="CheckDraft();">';
				if ($icon_folder) {
				    echo '<img src="'.$base_uri.'images/'.$custom_css.'/save_as_draft.gif" name="img_draft" title="'._("Save as draft").'" border=0>';
				    echo '<br>';
				}
				echo codeHTML(_("Save as draft"));
			    echo '</td>'."\n";
			}		
			echo '<td align="center" width="1px" class="navseparator"></td>';

		    	echo '<td nowrap=1 class="altnav" id="openpriority" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="70" onClick="OpenPriority()">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/priority.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Priority"));
			echo '</td>'."\n";		

		        echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="70" onclick="AssignSignature()">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/signature.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Signature"));
			echo '</td>'."\n";		

			if (!preg_match('/Konqueror/i', $HTTP_USER_AGENT)) {
		    	    echo '<td nowrap=1 class="altnav" height="100%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="70" onclick="ModifyHTMLarea()">';
				if ($icon_folder) {
				    echo '<img src="'.$base_uri.'images/'.$custom_css.'/htmlarea.gif" border=0>';
				    echo '<br>';
				}
				if ($use_htmlarea) {
				    echo '<div id="htmlarea_text_button">'.codeHTML(_("Text Area")).'</div>';
				} else {
				    echo '<div id="htmlarea_text_button">'.codeHTML(_("HTML Area")).'</div>';
				}
			}
			echo '</td>'."\n";		

			echo '<td align="center" width="1px" class="navseparator"></td>';
		    echo "</tr>\n";
		echo  "</table>\n\n";
	    echo '</td>'."\n";		
	    echo '<td align="right" height="100%" class="altaltnav" valign="top">';
		echo '<table border=0 height="100%" valign="top" align="right" cellspacing="0" cellpadding="0">';
		    echo '<tr height="100%">';
		        echo '<td nowrap=1 class="altnav" height="100%" valign="middle" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'altnav\'" width="70" onclick="self.close()">';
			    if ($icon_folder) {
				echo '<img src="'.$base_uri.'images/'.$custom_css.'/logoff.gif" border=0>';
				echo '<br>';
			    }
			    echo codeHTML(_("Close"));
			echo '</td>'."\n";		
		    echo "</tr>\n";
		echo  "</table>\n\n";
	    echo '</td>'."\n";		
	echo "</tr>\n";
    echo  "</table>\n\n";
}

/* ----------------------------------------------------------------------- */

/*
 * If the session is expired during a post this restores the compose session
 * vars.
 */
if (sqsession_is_registered('session_expired_post')) {
    sqgetGlobalVar('session_expired_post', $session_expired_post, SQ_SESSION);
    /*
     * extra check for username so we don't display previous post data from
     * another user during this session.
     */
    if ($session_expired_post['username'] != $username) {
        unset($session_expired_post);
        sqsession_unregister('session_expired_post');
        session_write_close();
    } else {
        foreach ($session_expired_post as $postvar => $val) {
            if (isset($val)) {
                $$postvar = $val;
            } else {
                $$postvar = '';
            }
        }
        $compose_messages = unserialize(urldecode($restoremessages));
        sqsession_register($compose_messages,'compose_messages');
        sqsession_register($composesession,'composesession');
        if (isset($send)) { unset($send); }
        $session_expired = true;
    }
    unset($session_expired_post);
    sqsession_unregister('session_expired_post');
    session_write_close();
    if (!isset($mailbox)) {
        $mailbox = '';
    }
    compose_Header_overlook($color, $mailbox);
    showInputForm($session, false);
    exit();
}
if (!isset($composesession)) {
    $composesession = 0;
    sqsession_register(0,'composesession');
}

if (!isset($session) || (isset($newmessage) && $newmessage)) {
    sqsession_unregister('composesession');
    $session = "$composesession" +1;
    $composesession = $session;
    sqsession_register($composesession,'composesession');
}
if (!isset($compose_messages)) {
  $compose_messages = array();
}
if (!isset($compose_messages[$session]) || ($compose_messages[$session] == NULL)) {
/* if (!array_key_exists($session, $compose_messages)) {  /* We can only do this in PHP >= 4.1 */
  $composeMessage = new Message();
  $rfc822_header = new Rfc822Header();
  $composeMessage->rfc822_header = $rfc822_header;
  $composeMessage->reply_rfc822_header = '';
  $compose_messages[$session] = $composeMessage;
  sqsession_register($compose_messages,'compose_messages');
} else {
  $composeMessage=$compose_messages[$session];
}

if (!isset($mailbox) || $mailbox == '' || ($mailbox == 'None')) {
    $mailbox = 'INBOX';
}

// carico elemento firma
$idents = getPref($data_dir, $username, 'identities', 0);

$arraysignature[0] = getSig($data_dir, $username, "g"); 
if ($idents > 1) {
    for ($i=1;$i<$idents;$i++) {
	$arraysignature[$i] = getSig($data_dir, $username, $i);
    }
}

if ($draft) {
    /*
     * Set $default_charset to correspond with the user's selection
     * of language interface.
     */
    set_my_charset();

    checkInput(true);

    $composeMessage=$compose_messages[$session];
    if (! deliverMessage($composeMessage, true)) {
	sqgetGlobalVar('send_to',$send_to);
	sqgetGlobalVar('send_to_cc',$send_to_cc);
	sqgetGlobalVar('send_to_bcc',$send_to_bcc);
        compose_Header_overlook($color, $mailbox);
        showInputForm($session);
        exit();
    } else {
        unset($compose_messages[$session]);
        $draft_message = _("Draft Email Saved");
        /* If this is a resumed draft, then delete the original */
        if(isset($delete_draft)) {
            Header("Location: ".$base_uri."src/delete_message.php?mailbox=" . urlencode($draft_folder) .
                   "&message=$delete_draft&sort=$sort&startMessage=1&saved_draft=yes");
            exit();
        } else {
	    displayHtmlHeader (_("Compose")); 
	    echo '<body onload="self.close();"></body></html>';
            exit();
        }
    }
}

if ($send) {
    if (isset($_FILES['attachfile']) &&
        $_FILES['attachfile']['tmp_name'] &&
        $_FILES['attachfile']['tmp_name'] != 'none') {
        $AttachFailure = saveAttachedFiles($session);
    }
    if (checkInput(false) && !isset($AttachFailure)) {
                if ($mailbox == "All Folders") {
                        /* We entered compose via the search results page */
                        $mailbox="INBOX"; /* Send 'em to INBOX, that's safe enough */
                }
        $urlMailbox = urlencode (trim($mailbox));
        if (! isset($passed_id)) {
            $passed_id = 0;
        }
        /*
         * Set $default_charset to correspond with the user's selection
         * of language interface.
         */
        set_my_charset();
        /*
         * This is to change all newlines to \n
         * We'll change them to \r\n later (in the sendMessage function)
         */
        $body = str_replace("\r\n", "\n", $body);
        $body = str_replace("\r", "\n", $body);

        /*
         * Rewrap $body so that no line is bigger than $editor_size
         * This should only really kick in the sqWordWrap function
         * if the browser doesn't support "VIRTUAL" as the wrap type.
         */
        $body = explode("\n", $body);
        $newBody = '';
        foreach ($body as $line) {
            if( $line <> '-- ' ) {
               $line = rtrim($line);
            }
            if (strlen($line) <= $editor_size + 1) {
                $newBody .= $line . "\n";
            } else {
                sqWordWrap($line, $editor_size);
                $newBody .= $line . "\n";

            }

        }
        $body = $newBody;
        $composeMessage=$compose_messages[$session];

        $Result = deliverMessage($composeMessage);
        if (! $Result) {
    	    sqgetGlobalVar('send_to',$send_to);
	    sqgetGlobalVar('send_to_cc',$send_to_cc);
	    sqgetGlobalVar('send_to_bcc',$send_to_bcc);
	    compose_Header_overlook($color, $mailbox);
            showInputForm($session);
            exit();
        }
        unset($compose_messages[$session]);
        if ( isset($delete_draft)) {
            Header("Location: ".$base_uri."src/delete_message.php?mailbox=" . urlencode( $draft_folder ).
                   "&message=$delete_draft&sort=$sort&startMessage=1&mail_sent=yes");
            exit();
        } else {
	    displayHtmlHeader (_("Compose")); 
	    echo '<body onload="self.close();"></body></html>';
	    exit();
        }
    } else {
        compose_Header_overlook($color, $mailbox);
        if (isset($AttachFailure)) {
             plain_error_message(codeHTML(_("Could not move/copy file. File not attached")),
                                 $color);
        }
        checkInput(true);
        showInputForm($session);
        /* sqimap_logout($imapConnection); */
    }
} elseif ($attach) {
    if (saveAttachedFiles($session)) {
        plain_error_message(codeHTML(_("Could not move/copy file. File not attached")), $color);
    }
    compose_Header_overlook($color, $mailbox);
    showInputForm($session);
} elseif ($do_delete) {
    compose_Header_overlook($color, $mailbox);
    if (isset($delete) && is_array($delete)) {
        $composeMessage = $compose_messages[$session];
        foreach($delete as $index) {
            $attached_file = $composeMessage->entities[$index]->att_local_name;
            unlink ($attached_file);
            unset ($composeMessage->entities[$index]);
        }
        $new_entities = array();
        foreach ($composeMessage->entities as $entity) {
            $new_entities[] = $entity;
        }
        $composeMessage->entities = $new_entities;
        $compose_messages[$session] = $composeMessage;
        sqsession_register($compose_messages, 'compose_messages');
    }
    showInputForm($session);
} else {
    /*
     * This handles the default case as well as the error case
     * (they had the same code) --> if (isset($smtpErrors))
     */

    compose_Header_overlook($color, $mailbox);

    $newmail = true;

    if (!isset($passed_ent_id)) {
        $passed_ent_id = '';
    }
    if (!isset($passed_id)) {
        $passed_id = '';
    }
    if (!isset($mailbox)) {
        $mailbox = '';
    }
    if (!isset($action)) {
        $action = '';
    }

    $values = newMail($mailbox,$passed_id,$passed_ent_id, $action, $session);

    /* in case the origin is not read_body.php */
    if (isset($send_to)) {
       $values['send_to'] = $send_to;
    }
    if (isset($send_to_cc)) {
       $values['send_to_cc'] = $send_to_cc;
    }
    if (isset($send_to_bcc)) {
       $values['send_to_bcc'] = $send_to_bcc;
    }
    if (isset($subject)) {
       $values['subject'] = $subject;
    }
    showInputForm($session, $values);
}

exit();

/**************** Only function definitions go below *************/


/* This function is used when not sending or adding attachments */
function newMail ($mailbox='', $passed_id='', $passed_ent_id='', $action='', $session='') {
    global $editor_size, $default_use_priority, $body,
           $use_signature, $composesession, $data_dir, $username,
           $username, $key, $imapServerAddress, $imapPort, $compose_messages,
           $composeMessage;
    global $languages, $squirrelmail_language;

    global $color, $wrap_at, $show_html_default, $use_htmlarea;

    $send_to = $send_to_cc = $send_to_bcc = $subject = $identity = '';
    $mailprio = 3;

    if ($passed_id) {
        $imapConnection = sqimap_login($username, $key, $imapServerAddress,
        $imapPort, 0);

        sqimap_mailbox_select($imapConnection, $mailbox);
        $message = sqimap_get_message($imapConnection, $passed_id, $mailbox);

        $body = '';
        if ($passed_ent_id) {
            /* redefine the messsage in case of message/rfc822 */
            $message = $message->getEntity($passed_ent_id);
            /* message is an entity which contains the envelope and type0=message
            * and type1=rfc822. The actual entities are childs from
            * $message->entities[0]. That's where the encoding and is located
            */

            $entities = $message->entities[0]->findDisplayEntity
            (array(), $alt_order = array('text/plain'));
            if (!count($entities)) {
                $entities = $message->entities[0]->findDisplayEntity
                (array(), $alt_order = array('text/plain','html/plain'));
            }
            $orig_header = $message->rfc822_header; /* here is the envelope located */
            /* redefine the message for picking up the attachments */
            $message = $message->entities[0];

        } else {
            $entities = $message->findDisplayEntity (array(), $alt_order = array('text/plain'));
            if (!count($entities)) {
                $entities = $message->findDisplayEntity (array(), $alt_order = array('text/plain','html/plain'));
            }
            $orig_header = $message->rfc822_header;
        }

	if ($use_htmlarea) {
	    if ($show_html_default == 1) {
    		$ent_ar = $message->findDisplayEntity(array());
	    } else {
    		$ent_ar = $message->findDisplayEntity(array(), array('text/plain'));
	    }
	    $cnt = count($ent_ar);
	    $body = '';
	    for ($i = 0; $i < $cnt; $i++) {
    		$body .= formatBody($imapConnection, $message, $color, $wrap_at, $ent_ar[$i], $passed_id, $mailbox,1);
    	    	if ($i != $cnt-1) {
        	    $body .= '<hr noshade size=1>';
    		}
	    }
	} else {
    	    $encoding = $message->header->encoding;
    	    $type0 = $message->type0;
    	    $type1 = $message->type1;
    	    foreach ($entities as $ent) {
        	$unencoded_bodypart = mime_fetch_body($imapConnection, $passed_id, $ent);
        	$body_part_entity = $message->getEntity($ent);
        	$bodypart = decodeBody($unencoded_bodypart,$body_part_entity->header->encoding);

        	if ($type1 == 'html') {
            	    $bodypart = str_replace("\n", ' ', $bodypart);
            	    $bodypart = preg_replace(array('/<p>/i','/<br\s*(\/)*>/i'), "\n", $bodypart);
            	    $bodypart = str_replace(array('&nbsp;','&gt;','&lt;'),array(' ','>','<'),$bodypart);
            	    $bodypart = strip_tags($bodypart);
        	}

        	if (isset($languages[$squirrelmail_language]['XTRA_CODE']) &&
            	    function_exists($languages[$squirrelmail_language]['XTRA_CODE'])) {
            	    if (mb_detect_encoding($bodypart) != 'ASCII') {
                	$bodypart = $languages[$squirrelmail_language]['XTRA_CODE']('decode', $bodypart);
            	    }
        	}
        	$body .= $bodypart;
    	    }
	}
        if ($default_use_priority) {
            $mailprio = substr($orig_header->priority,0,1);
            if (!$mailprio) {
                $mailprio = 3;
            }
        } else {
            $mailprio = '';
        }
        //ClearAttachments($session);

        $identity = '';
        $idents = getPref($data_dir, $username, 'identities');
        $from_o = $orig_header->from;
        if (is_array($from_o)) {
            if (isset($from_o[0])) {
                $from_o = $from_o[0];
            }
        }
        if (is_object($from_o)) {
            $orig_from = $from_o->getAddress();
        } else {
            $orig_from = '';
        }
        $identities = array();
        if (!empty($idents) && $idents > 1) {
            $identities[]  = '"'. getPref($data_dir, $username, 'full_name')
              . '" <' .  getPref($data_dir, $username, 'email_address') . '>';
            for ($i = 1; $i < $idents; $i++) {
                $enc_from_name = '"'.
                    getPref($data_dir, $username, 'full_name' . $i) .
                        '" <' .
                    getPref($data_dir, $username, 'email_address' . $i) . '>';
                if ($enc_from_name == $orig_from && $i) {
                    $identity = $i;
                    break;
                }
                $identities[] = $enc_from_name;
            }

            $identity_match = $orig_header->findAddress($identities);
            if ($identity_match) {
                $identity = $identity_match;
            }
        }

        switch ($action) {
        case ('draft'):
            $use_signature = FALSE;
            $composeMessage->rfc822_header = $orig_header;
            $send_to = decodeHeader($orig_header->getAddr_s('to'),false,false);
            $send_to_cc = decodeHeader($orig_header->getAddr_s('cc'),false,false);
            $send_to_bcc = decodeHeader($orig_header->getAddr_s('bcc'),false,false);
            $subject = decodeHeader($orig_header->subject,false,false);
//            /* remember the references and in-reply-to headers in case of an reply */
            $composeMessage->rfc822_header->more_headers['References'] = $orig_header->references;
            $composeMessage->rfc822_header->more_headers['In-Reply-To'] = $orig_header->in_reply_to;
            $body_ary = explode("\n", $body);
            $cnt = count($body_ary) ;
            $body = '';
            for ($i=0; $i < $cnt; $i++) {
                if (!ereg("^[>\\s]*$", $body_ary[$i])  || !$body_ary[$i]) {
                    sqWordWrap($body_ary[$i], $editor_size );
                    $body .= $body_ary[$i] . "\n";
                }
                unset($body_ary[$i]);
            }
            sqUnWordWrap($body);
            $composeMessage = getAttachments($message, $composeMessage, $passed_id, $entities, $imapConnection);
            break;
        case ('edit_as_new'):
            $send_to = decodeHeader($orig_header->getAddr_s('to'),false,false);
            $send_to_cc = decodeHeader($orig_header->getAddr_s('cc'),false,false);
            $send_to_bcc = decodeHeader($orig_header->getAddr_s('bcc'),false,false);
            $subject = decodeHeader($orig_header->subject,false,false);
            $mailprio = $orig_header->priority;
            $orig_from = '';
            $composeMessage = getAttachments($message, $composeMessage, $passed_id, $entities, $imapConnection);
            sqUnWordWrap($body);
            break;
        case ('forward'):
            $send_to = '';
            $subject = decodeHeader($orig_header->subject,false,false);
            if ((substr(strtolower($subject), 0, 4) != 'fwd:') &&
                (substr(strtolower($subject), 0, 5) != '[fwd:') &&
                (substr(strtolower($subject), 0, 6) != '[ fwd:')) {
                $subject = '[Fwd: ' . $subject . ']';
            }
            $body = getforwardHeader($orig_header) . $body;
            sqUnWordWrap($body);
            $composeMessage = getAttachments($message, $composeMessage, $passed_id, $entities, $imapConnection);
            $body = "\n" . $body;
            break;
        case ('forward_as_attachment'):
            $composeMessage = getMessage_RFC822_Attachment($message, $composeMessage, $passed_id, $passed_ent_id, $imapConnection);
            $body = '';
            break;
        case ('reply_all'):
            $send_to_cc = replyAllString($orig_header);
            $send_to_cc = decodeHeader($send_to_cc,false,false);
        case ('reply'):
            $send_to = $orig_header->reply_to;
            if (is_array($send_to) && count($send_to)) {
                $send_to = $orig_header->getAddr_s('reply_to');
            } else if (is_object($send_to)) { /* unnessecarry, just for falesafe purpose */
                $send_to = $orig_header->getAddr_s('reply_to');
            } else {
                $send_to = $orig_header->getAddr_s('from');
            }
            $send_to = decodeHeader($send_to,false,false);
            $subject = decodeHeader($orig_header->subject,false,false);
            $subject = str_replace('"', "'", $subject);
            $subject = trim($subject);
            if (substr(strtolower($subject), 0, 3) != 're:') {
                $subject = 'Re: ' . $subject;
            }
            /* this corrects some wrapping/quoting problems on replies */
            $rewrap_body = explode("\n", $body);
            $from =  (is_array($orig_header->from)) ? $orig_header->from[0] : $orig_header->from;
            sqUnWordWrap($body);
	    //double check for a an encrypted body before displaying
	    $sep = '-----BEGIN PGP MESSAGE-----';
	    $end = '-----END PGP MESSAGE-----';
            $body = '';
	    $pgp_start=0;
	    $pgp_stop=0;
            $cnt = count($rewrap_body);
            for ($i=0;$i<$cnt;$i++) {
              sqWordWrap($rewrap_body[$i], ($editor_size));
		if (preg_match("/$sep/", $rewrap_body[$i])) { $pgp_start=1; }
		if (preg_match("/$end/", $rewrap_body[$i])) { $pgp_stop=1; }
		if ($pgp_start==1) { 
		    $body .= rtrim($rewrap_body[$i])."\n";		
		//inserisce il > come carattere per citazione
                } else if (preg_match("/^(>+)/", $rewrap_body[$i], $matches)) {
                    $gt = $matches[1];
                    $body .= '>' . str_replace("\n", "\n>$gt ", rtrim($rewrap_body[$i])) ."\n";
                } else {
                    $body .= '> ' . str_replace("\n", "\n> ", rtrim($rewrap_body[$i])) . "\n";
                }
                unset($rewrap_body[$i]);
		if ($pgp_start==1 && $pgp_stop==1) { $pgp_start=0; $pgp_stop=0; } 
            }
	    $body = getReplyCitation($from , $orig_header->date) . $body;
            $composeMessage->reply_rfc822_header = $orig_header;

            break;
        default:
            break;
        }
        $compose_messages[$session] = $composeMessage;
        sqsession_register($compose_messages, 'compose_messages');
        session_write_close();
        sqimap_logout($imapConnection);
    }
    $ret = array( 'send_to' => $send_to,
                  'send_to_cc' => $send_to_cc,
                  'send_to_bcc' => $send_to_bcc,
                  'subject' => $subject,
                  'mailprio' => $mailprio,
                  'body' => $body,
                  'identity' => $identity );

    return ($ret);
} /* function newMail() */

function getAttachments($message, &$composeMessage, $passed_id, $entities, $imapConnection) {
    global $attachment_dir, $username, $data_dir, $squirrelmail_language;
    $hashed_attachment_dir = getHashedDir($username, $attachment_dir);
    if (!count($message->entities) ||
       ($message->type0 == 'message' && $message->type1 == 'rfc822')) {
        if ( !in_array($message->entity_id, $entities) && $message->entity_id) {
           switch ($message->type0) {
           case 'message':
                if ($message->type1 == 'rfc822') {
                    $filename = $message->rfc822_header->subject;
                    if ($filename == "") {
                        $filename = "untitled-".$message->entity_id;
                    }
		    $filename .= '.msg';
                 } else {
                   $filename = $message->getFilename();
                 }
             break;
           default:
             if (!$message->mime_header) { /* temporary hack */
                 $message->mime_header = $message->header;
             }
             $filename = $message->getFilename();
             break;
           }
	   $filename = decodeHeader($filename, false, false);
           if (isset($languages[$squirrelmail_language]['XTRA_CODE']) &&
               function_exists($languages[$squirrelmail_language]['XTRA_CODE'])) {
                $filename =  $languages[$squirrelmail_language]['XTRA_CODE']('encode', $filename);
           }
           $localfilename = GenerateRandomString(32, '', 7);
           $full_localfilename = "$hashed_attachment_dir/$localfilename";
           while (file_exists($full_localfilename)) {
               $localfilename = GenerateRandomString(32, '', 7);
               $full_localfilename = "$hashed_attachment_dir/$localfilename";
           }
           $message->att_local_name = $full_localfilename;

	   $composeMessage->initAttachment($message->type0.'/'.$message->type1,$filename,
             $full_localfilename);

           /* Write Attachment to file */
           $fp = fopen ("$hashed_attachment_dir/$localfilename", 'wb');
           fputs($fp, decodeBody(mime_fetch_body($imapConnection,
              $passed_id, $message->entity_id),
              $message->header->encoding));
           fclose ($fp);
        }
    } else {
        for ($i=0, $entCount=count($message->entities); $i<$entCount;$i++) {
            $composeMessage=getAttachments($message->entities[$i], $composeMessage, $passed_id, $entities, $imapConnection);
        }
    }
    return $composeMessage;
}

function getMessage_RFC822_Attachment($message, $composeMessage, $passed_id,
                                      $passed_ent_id='', $imapConnection) {
    global $attachments, $attachment_dir, $username, $data_dir, $uid_support;
    $hashed_attachment_dir = getHashedDir($username, $attachment_dir);
    if (!$passed_ent_id) {
        $body_a = sqimap_run_command($imapConnection,
                                    'FETCH '.$passed_id.' RFC822',
                                    TRUE, $response, $readmessage,
                                    $uid_support);
    } else {
        $body_a = sqimap_run_command($imapConnection,
                                     'FETCH '.$passed_id.' BODY['.$passed_ent_id.']',
                                     TRUE, $response, $readmessage, $uid_support);
        $message = $message->parent;
    }
    if ($response == 'OK') {
        $subject = encodeHeader($message->rfc822_header->subject);
        array_shift($body_a);
        array_pop($body_a);
        $body = implode('', $body_a) . "\r\n";

        $localfilename = GenerateRandomString(32, 'FILE', 7);
        $full_localfilename = "$hashed_attachment_dir/$localfilename";

        $fp = fopen($full_localfilename, 'w');
        fwrite ($fp, $body);
        fclose($fp);
        $composeMessage->initAttachment('message/rfc822',$subject.'.msg',
                         $full_localfilename);
    }
    return $composeMessage;
}

function showInputForm ($session, $values=false) {
    global $send_to, $send_to_cc, $body, $startMessage,$base_uri,$use_htmlarea,
           $passed_body, $color, $use_signature, $signature, $prefix_sig,$delimiter,
           $editor_size, $editor_height, $attachments, $subject, $newmail,
           $use_javascript_addr_book, $send_to_bcc, $passed_id, $mailbox,
           $from_htmladdr_search, $attachment_dir, $custom_css,
           $username, $data_dir, $identity, $draft_id, $delete_draft,
           $mailprio, $default_use_mdn, $mdn_user_support, $compose_new_win,
           $saved_draft, $mail_sent, $sig_first, $edit_as_new, $action,
           $username, $compose_messages, $composesession, $default_charset,
	   $name_newsletter,$newsletter,$request_mdn,$request_dr,
	   $sign_on_send,$encrypt_on_send;

    $composeMessage = $compose_messages[$session];

    global $username, $key, $imapServerAddress, $imapPort, $mailbox, $color, $wrap_at, 
	    $passed_id, $language, $htmlarea_skin, $default_folder_prefix, $sent_folder,
	    $trash_folder, $draft_folder;

    if ($values) {
    	$send_to = $values['send_to'];
    	$send_to_cc = $values['send_to_cc'];
    	$send_to_bcc = $values['send_to_bcc'];
    	$subject = $values['subject'];
    	$mailprio = $values['mailprio'];
    	$body = $values['body'];
        $identity = (int) $values['identity'];
    } else {
       $send_to = decodeHeader($send_to, true, false);
       $send_to_cc = decodeHeader($send_to_cc, true, false);
       $send_to_bcc = decodeHeader($send_to_bcc, true, false);
    }
    echo addForm($base_uri.'src/compose.php', 'POST', 'compose','multipart/form-data');

    echo addHidden('startMessage', $startMessage);
    if ($action == 'draft') { 
	echo addHidden('delete_draft', $passed_id);
    } else if (isset($delete_draft)) {
	echo addHidden('delete_draft', $delete_draft);
    }
    if (isset($session)) { echo addHidden('session', $session); }
    echo addHidden('username', $username);
    echo addHidden('smaction', $action);
    echo addHidden('mailbox', $mailbox);

    sqgetGlobalVar('QUERY_STRING', $queryString, SQ_SERVER);

    echo addHidden('restoremessages', serialize($compose_messages));
    echo addHidden('composesession', $composesession);
    echo addHidden('querystring', $queryString);

    // priority	
    if(!isset($mailprio)) { $mailprio = "3"; }
    echo addHidden('mailprio', $mailprio);
    echo addHidden('draft', '0');
    echo addHidden('send', '0');
    echo addHidden('use_hidden_htmlarea', $use_htmlarea);

    // tasti submit
    echo '<div id="div_priority" style="position:absolute;z-index:16;visibility:hidden;top:0px;left:0px;">
	    <table align="left" valign="top" class="border" cellpadding=2 cellspacing=0 border=0>
		<tr><td onClick="ChangePriority(1)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("High priority")).'</td></tr>
		<tr><td onClick="ChangePriority(3)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("Normal priority")).'</td></tr>
		<tr><td onClick="ChangePriority(5)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("Low priority")).'</td></tr>
	    </table>
	</div>';
    echo '<table valign="top" cellpadding=0 cellspacing=0 border=0 width="100%" height="100%">'."\n";
	echo '<tr><td valign="top">';
	    displayNavigationCompose($mailbox);
	echo '</td></tr>';
	echo '<tr><td valign="top">';
	    echo '<table class="border" width="100%" height="100%" align="center" cellspacing=2 cellpadding=3 border=0 valign="top">' . "\n";
		echo '<tr>';
		    if ($mailprio == 1) {
			echo '<td id="td_priority" colspan=2 align="left" width="100%" class="priorityhigh">'.codeHTML(_("The message has high priority")).'</td>';
		    } else if ($mailprio == 3) {
			echo '<td id="td_priority" colspan=2 align="left" width="100%" class="prioritynormal">'.codeHTML(_("The message has normal priority")).'</td>';
		    } else if ($mailprio == 5) {
			echo '<td id="td_priority" colspan=2 align="left" width="100%" class="prioritylow">'.codeHTML(_("The message has low priority")).'</td>';
		    }
		echo '</tr>';

    /* display select list for identities */
    $idents = getPref($data_dir, $username, 'identities', 0);
        $fn = getPref($data_dir, $username, 'full_name');
        $em = getPref($data_dir, $username, 'email_address');
	echo '<tr>';
	echo '<td align="left" class="nav" width="10%">'.codeHTML(_("From:")).'</td>';
	echo '<td align="left" class="nav" width="90%">';
	    $new_option = array();	    
    	    if ($em != '') {
        	if ($fn != '') { $new_option['default'] = $fn.' <' . $em . '>'; } 
		else { $new_option['default'] = $em; }
    	    } else { $new_option['default'] = $fn; }
    	    for ($i = 1; $i < $idents; $i ++) {
        	$fn = getPref($data_dir, $username, 'full_name' . $i);
        	$em = getPref($data_dir, $username, 'email_address' . $i);
    		if ($em != '') {
        	    if ($fn != '') { $new_option[$i] = $fn.' <' . $em . '>'; } 
		    else { $new_option[$i] = $em; }
    		} else { $new_option[$i] = $fn; }
    	    }
	    echo addSelect('identity', $new_option, $identity, TRUE, 'style="width:400px"');
	echo '</td></tr>'."\n";
    echo '<tr>';
	echo '<td onClick="new_win_overlook(\'addr_popup\',\''.$base_uri.'src/addressbook_popup.php\',600,400,1,100,100)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav" align="left" width="10%"><img border=0 src="'.$base_uri.'images/'.$custom_css.'/address_small.gif">&nbsp;'.codeHTML(_("To:")).'</td>';
	echo '<td class="nav" align="left" width="90%">';
	    echo addInput('send_to',$send_to,'','','id="send_to" style="width:400px"');
	echo '</td>';
    echo '</tr>'."\n";
    echo '<tr>';
	echo '<td onClick="new_win_overlook(\'addr_popup\',\''.$base_uri.'src/addressbook_popup.php\',600,400,1,100,100)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav" align="left" width="10%"><img border=0 src="'.$base_uri.'images/'.$custom_css.'/address_small.gif">&nbsp;'.codeHTML(_("CC:")).'</td>';
	echo '<td class="nav" align="left" width="90%">';
	    echo addInput('send_to_cc',$send_to_cc,'','','id="send_to_cc" style="width:400px"');
	echo '</td>';
    echo '</tr>'."\n";
    echo '<tr>';
	echo '<td onClick="new_win_overlook(\'addr_popup\',\''.$base_uri.'src/addressbook_popup.php\',600,400,1,100,100)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav" align="left" width="10%"><img border=0 src="'.$base_uri.'images/'.$custom_css.'/address_small.gif">&nbsp;'.codeHTML(_("BCC:")).'</td>';
	echo '<td class="nav" align="left" width="90%">';
	    echo addInput('send_to_bcc',$send_to_bcc,'','','id="send_to_bcc" style="width:400px"');
	echo '</td>';
    echo '</tr>'."\n";

    echo '<tr>';
	echo '<td class="nav" align="left" width="10%">'.codeHTML(_("NewsLetter:")).'</td>';
	echo '<td class="nav" align="left" width="90%">';
	    if (!$name_newsletter) {
		$name_newsletter=_("This text replaces the showed To: address");
	    }
	    echo addCheckBox('newsletter', (isset($newsletter) && $newsletter=='1' ? TRUE : FALSE), 1, 'onMouseOver="showtip(event,\'div_name_newsletter\')" onMouseOut="hidetip(\'div_name_newsletter\')" onClick="ChangeNewsletter()"');
	    echo addInput('name_newsletter',$name_newsletter,'','30','id="name_newsletter" disabled=1 style="width:378px" maxlenght="30"');
	echo '</td>';
    echo '</tr>'."\n";

    echo '<tr>';
	echo '<td class="nav" align="left" width="10%">'.codeHTML(_("Subject:")).'</td>';
	echo '<td class="nav" align="left" width="90%">';
	    echo addInput('subject', $subject,'', '','style="width:400px"');
	echo '</td>';
    echo '</tr>'."\n";

    $mdn_user_support=getPref($data_dir, $username, 'mdn_user_support',$default_use_mdn);

    if ($mailbox && $mailbox.$delimiter != $default_folder_prefix 
	&& $mailbox != $sent_folder && $mailbox != $trash_folder && $mailbox != $draft_folder) {
	$patermailbox = $mailbox;
    } else {
	$patermailbox = $sent_folder;
    }
    $showpatermailbox = imap_utf7_decode_local($patermailbox);
    $a = explode($delimiter,$showpatermailbox);
    $showpatermailbox = array_pop($a);
    echo '<tr>';
    if ($default_use_mdn && $mdn_user_support) {
	echo '<td class="nav" align="left" width="10%">'.codeHTML(_("Receipt:")).'</td>';
	echo '<td class="nav" align="left" width="90%">';
	    echo addCheckBox('request_mdn', (isset($request_mdn) && $request_mdn=='1' ? TRUE : FALSE), 1)._("On Read");
	    echo addCheckBox('request_dr', (isset($request_dr) && $request_dr=='1' ? TRUE : FALSE), 1)._("On Delivery");
	    echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    } else {
	echo '<td class="nav" align="left" width="10%">'.codeHTML(_("Save in:")).'</td>';
	echo '<td class="nav" align="left" width="90%">';
    }
	    echo addHidden('sent_folder', $patermailbox).'&nbsp;';	
	    echo addInput('sent_folder_label', $showpatermailbox, '20', '','disabled=1').'&nbsp;';
	    echo addButton(_("Save sent message here"),'', '','new_win_overlook("move_email","'.$base_uri.'src/search_folder.php",400,333,1,180,150);','compose','',1,1);
	echo '</td>';
    echo '</tr>'."\n";

    do_hook('compose_button_row');

    echo '<tr>';
    echo '<td class="nav" align="left" colspan=2 width="100%">';
    if ($use_htmlarea) {
	$text = '';
	if ($use_signature == true && $newmail == true && !isset($from_htmladdr_search)) {
    	    if ($idents > 1) {
        	if ($identity == 'default') {
            	    $no = 'g';
    		} else {
        	    $no = $identity;
    		}
    		$signature = getSig($data_dir, $username, $no);
	    }
	    if ($sig_first == '1') {
		if ($default_charset == 'iso-2022-jp') {
        	    $text .= "<BR><BR>".($prefix_sig==true? "-- <BR>":'').mb_convert_encoding($signature, 'EUC-JP');
    		} else {
    		    $text .=  "<BR><BR>".($prefix_sig==true? "-- <BR>":'').codeHTML(decodeHeader($signature,false,false));
    		}
		$text .= "<BR><BR>".$body;
	    } else {
		$text .= "<BR><BR>".$body;
    		if ($default_charset == 'iso-2022-jp') {
        	    $text .= "<BR><BR>".($prefix_sig==true? "-- <BR>":'').mb_convert_encoding($signature, 'EUC-JP');
    		} else {
        	    $text .= "<BR><BR>".($prefix_sig==true? "-- <BR>":'').codeHTML(decodeHeader($signature,false,false));
    		}
	    }
	} else {
	    $text .= $body;
	}
    } else {
	$text = '';
	if ($use_signature == true && $newmail == true && !isset($from_htmladdr_search)) {
    	    if ($idents > 1) {
        	if ($identity == 'default') {
            	    $no = 'g';
    		} else {
        	    $no = $identity;
    		}
    		$signature = getSig($data_dir, $username, $no);
	    }
	    if ($sig_first == '1') {
		if ($default_charset == 'iso-2022-jp') {
        	    $text .= "\n\n".($prefix_sig==true? "-- \n":'').mb_convert_encoding($signature, 'EUC-JP');
    		} else {
    		    $text .=  "\n\n".($prefix_sig==true? "-- \n":'').decodeHeader($signature,false,false);
    		}
		$text .= "\n\n".decodeHeader($body,false,false);
	    } else {
		$text .= "\n\n".decodeHeader($body,false,false);
    		if ($default_charset == 'iso-2022-jp') {
        	    $text .= "\n\n".($prefix_sig==true? "-- \n":'').mb_convert_encoding($signature, 'EUC-JP');
    		} else {
        	    $text .= "\n\n".($prefix_sig==true? "-- \n":'').decodeHeader($signature,false,false);
    		}
	    }
	} else {
	    $text .= decodeHeader($body,false,false);
	}
    }

    if ($use_htmlarea) { 
	$oFCKeditor = new FCKeditor('bodymsg');
	$oFCKeditor->BasePath = $base_uri."FCKeditor/";
	$oFCKeditor->ToolbarSet = 'Overlook';
	if ($language) {
    	    $oFCKeditor->Config['AutoDetectLanguage'] = false;
    	    $oFCKeditor->Config['DefaultLanguage'] = substr($language,0,2);
	}
	if ($htmlarea_skin) {
	    $oFCKeditor->Config['SkinPath'] = $base_uri."FCKeditor/editor/skins/".$htmlarea_skin."/";
	}
	if ($editor_height) {
	    $oFCKeditor->Height = $editor_height;
	}
	$oFCKeditor->Value = $text;
	$oFCKeditor->Create();
    } else {
	echo addTextArea('bodymsg', $text, 0, 0, 'style="width:100%;height:'.$editor_height.';" ID="bodymsg"', 1);
    }
		echo '</td>';
	    echo '</tr>'."\n";	    
	echo '</table>'."\n";
    echo '</td></tr>';
    
    /* This code is for attachments */
if ((bool) ini_get('file_uploads')) {

    /* Calculate the max size for an uploaded file.
     * This is advisory for the user because we can't actually prevent
     * people to upload too large files. */
    $sizes = array();
    /* php.ini vars which influence the max for uploads */
    $configvars = array('post_max_size', 'memory_limit', 'upload_max_filesize');
    foreach($configvars as $var) {
        /* skip 0 or empty values */
        if( $size = getByteSize(ini_get($var)) ) {
            $sizes[] = $size;
        }
    }

    if(count($sizes) > 0) {
        $maxsize = '(max.&nbsp;' . show_readable_size( min( $sizes ) ) . ')';
    } else {
        $maxsize = '';
    }
    echo '<tr>';
    echo '<td valign="top">';
    echo '<table valign="top" class="border" width="100%" cellpadding="0" cellspacing="0" align="center" border=0>'."\n";
	echo '<tr>';
	    echo '<td class="nav" align="left">'.codeHTML(_("Attach:")).'</td>';
	    echo '<td class="nav" align="left">';
		echo addInputField('file', 'attachfile', '', 'size="40"');
		echo '&nbsp;&nbsp;';
		echo addHidden('attach', 1);
		echo addButton(_("Add"), '', '', 'if (!document.compose.attachfile.value) { alert("'.jsspecialchars(_("Could not move/copy file. File not attached")).'"); return false; }; ', 'compose','');
		echo '&nbsp;'.$maxsize;
	    echo '</td>';
	echo '</tr>';	       
    $s_a = array();
    if ($composeMessage->entities) {
        foreach ($composeMessage->entities as $key => $attachment) {
           $attached_file = $attachment->att_local_name;
           if ($attachment->att_local_name || $attachment->body_part) {
                $attached_filename = decodeHeader($attachment->mime_header->getParameter('name'));
                $type = $attachment->mime_header->type0.'/'.
                        $attachment->mime_header->type1;
                $s_a[] = "\n".'<table class="nav" border=0 cellpadding=0 cellspacing=0 valign="top">
				<tr>
				    <td>'.
					addCheckBox('delete[]', FALSE, $key).
				    '</td>
				    <td>'.$attached_filename.'</td>
				    <td>-</td>
				    <td>'.codeHTML($type).'</td>
				    <td>('.show_readable_size(filesize($attached_file)).')</td>
				</tr>
			    </table>'."\n";
           }
        }
    }
    if (count($s_a)) {
        foreach ($s_a as $s) {
            echo '<tr><td colspan=2 align="left" class="nav">'.$s.'</td></tr>'."\n";
        }
        echo '<tr><td class="nav" colspan="2">';
	    echo addHidden('do_delete',1);
	    echo addButton(_("Delete selected attachments"), '','','document.compose.attach.value=0;','compose');
	echo '</td></tr>'."\n";
    }
    echo '</table></TD></TR>'."\n";
} // End of file_uploads if-block

    echo '</FORM>';
    if (!(bool) ini_get('file_uploads')) {
      /* File uploads are off, so we didn't show that part of the form.
         To avoid bogus bug reports, tell the user why. */
      echo codeHTML('Because PHP file uploads are turned off, you can not attach files ');
      echo codeHTML("to this message.  Please see your system administrator for details.\r\n");
    }

//    do_hook('compose_bottom');

    echo '</table>';
    echo '<div id="div_name_newsletter" style="position:absolute;z-index:16;visibility:hidden;top:0px;left:0px;">
            <table class="optiontip" width="300pt" border=0 cellspacing=1 cellpadding=1>
                <tr>
                    <td aling="left" valign="top">
			'.codeHTML(_("Choosing newsletter your e-mail will be sent to all selected destinations as BCC (BlindCarbonCopy). The showed to: address will be the newsletter name itself.")).'
                    </td>
                </tr>
            </table>
        </div>';
    do_hook('compose_div');
    echo '</BODY></HTML>' . "\n";
}

function checkInput ($show) {
    /*
     * I implemented the $show variable because the error messages
     * were getting sent before the page header.  So, I check once
     * using $show=false, and then when i'm ready to display the error
     * message, show=true
     */
    global $body, $identity, $newsletter, $name_newsletter, $send_to, $send_to_bcc, $send_to_cc, $subject, $color, $username, $data_dir, $subject, $use_title_newsletter;

    if ($send_to == '' && $send_to_bcc == '') {
        if ($show) {
            plain_error_message(codeHTML(_("You have not filled in the \"To:\" field.")), $color);
        }
        return false;
    }
    $book = addressbook_init(true, true);
    $abook = $book[0];
    $gabook = $book[1];
    if (!$show) {
	if($abook->localbackend == 0) {
	    plain_error_message(
    		codeHTML(_("No personal address book is defined. Contact administrator.")),
    		$color);
	    return false;
	}
	$receivers = array(
		"send_to" => $send_to, 
		"send_to_cc" => $send_to_cc, 
		"send_to_bcc" => $send_to_bcc, 
	    );
	foreach ($receivers as $k => $value) {
	    if ($value) {
		$string_split = explode('"',$value);
		for ($i=0; $i < count($string_split); $i=$i+2) {
		    if ($string_split[$i]) {
			$string = $string_split[$i];
			// cerco gruppo pubblico
			preg_match_all('/\[\[([^\]]+)\]\]/', $string, $ag);
			for ($e=0; $e< count($ag[0]); $e++) {
			    $group = $ag[1][$e];
			    $data = $gabook->lookup($group, 2);
			    $contacts = array();
			    if ($data['group_list_public']) {
    				$contacts = $abook->lookup_group_id($data['group_list_public'], 2, 1);
			    }
			    $list_contacts = implode(";",$contacts);
			    $match = '[['.$group.']]';
			    $string = str_replace($match, $list_contacts, $string);
			}
			// cerco gruppo privato
			preg_match_all('/\[([^\]]+)\]/', $string, $ag);
			for ($e=0; $e< count($ag[0]); $e++) {
			    $group = $ag[1][$e];
			    $data = $gabook->lookup($group, 1);
			    $private_contacts = array();
			    $public_contacts = array();
			    if ($data['group_list_private']) {
    				$private_contacts = $abook->lookup_group_id($data['group_list_private'], 1, 1);
			    }
			    if ($data['group_list_public']) {
    				$public_contacts = $abook->lookup_group_id($data['group_list_public'], 2, 1);
			    }
			    $contacts = array_merge($public_contacts,$private_contacts);
			    $list_contacts = implode(";",$contacts);
			    $match = '['.$group.']';
			    $string = str_replace($match, $list_contacts, $string);
			} 
			$string_split[$i] = $string;
		    }
		}
		$final_value = implode('"',$string_split);
		$$k = $final_value;
	    }
	}
	if ($newsletter) {
	    if ($send_to_bcc){ 
		$send_to_bcc = $send_to_bcc.",".$send_to;
	    } else {
		$send_to_bcc = $send_to;
	    }
	    if ($send_to_cc){ 
		$send_to_bcc = $send_to_bcc.",".$send_to_cc;
	    }
	    if ($identity != "default") { $id = $identity; } else { $id = ""; } 
	    $send_to = '"'.$name_newsletter.'" <'.getPref($data_dir, $username, 'email_address' . $id).'>';
	    $send_to_cc = "";
	    if ($use_title_newsletter) {
		if ($subject) { $subject = "[$name_newsletter] ".$subject; } 
		else { $subject = "[$name_newsletter]"; }
	    }
    	}
    }
    return true;
} /* function checkInput() */


/* True if FAILURE */
function saveAttachedFiles($session) {
    global $_FILES, $attachment_dir, $attachments, $username,
           $data_dir, $compose_messages;

    /* get out of here if no file was attached at all */
    if (! is_uploaded_file($_FILES['attachfile']['tmp_name']) ) {
        return true;
    }

    $hashed_attachment_dir = getHashedDir($username, $attachment_dir);
    $localfilename = GenerateRandomString(32, '', 7);
    $full_localfilename = "$hashed_attachment_dir/$localfilename";
    while (file_exists($full_localfilename)) {
        $localfilename = GenerateRandomString(32, '', 7);
        $full_localfilename = "$hashed_attachment_dir/$localfilename";
    }

    // FIXME: we SHOULD prefer move_uploaded_file over rename because
    // m_u_f works better with restricted PHP installes (safe_mode, open_basedir)
    if (!@rename($_FILES['attachfile']['tmp_name'], $full_localfilename)) {
        if (!@move_uploaded_file($_FILES['attachfile']['tmp_name'],$full_localfilename)) {
            return true;
        }
    }
    $message = $compose_messages[$session];
    $type = strtolower($_FILES['attachfile']['type']);
    $name = $_FILES['attachfile']['name'];
    $message->initAttachment($type, $name, $full_localfilename);
    $compose_messages[$session] = $message;
    sqsession_register($compose_messages , 'compose_messages');
}

function ClearAttachments($composeMessage) {
    if ($composeMessage->att_local_name) {
        $attached_file = $composeMessage->att_local_name;
        if (file_exists($attached_file)) {
            unlink($attached_file);
        }
    }
    for ($i=0, $entCount=count($composeMessage->entities);$i< $entCount; ++$i) {
        ClearAttachments($composeMessage->entities[$i]);
    }
}

/* parse values like 8M and 2k into bytes */
function getByteSize($ini_size) {

    if(!$ini_size) {
        return FALSE;
    }

    $ini_size = trim($ini_size);

    // if there's some kind of letter at the end of the string we need to multiply.
    if(!is_numeric(substr($ini_size, -1))) {

        switch(strtoupper(substr($ini_size, -1))) {
            case 'G':
               $bytesize = 1073741824;
               break;
            case 'M':
               $bytesize = 1048576;
               break;
            case 'K':
               $bytesize = 1024;
               break;
        }

        return ($bytesize * (int)substr($ini_size, 0, -1));
    }

    return $ini_size;
}


/* temporary function to make use of the deliver class.
   In the future the responsable backend should be automaticly loaded
   and conf.pl should show a list of available backends.
   The message also should be constructed by the message class.
*/

function deliverMessage($composeMessage, $draft=false) {
    global $send_to, $send_to_cc, $send_to_bcc, $mailprio, $subject, $body,
           $username, $popuser, $usernamedata, $identity, $data_dir,$use_hidden_htmlarea,
           $request_mdn, $request_dr, $default_charset, $color, $useSendmail,
           $domain, $action, $default_move_to_sent, $move_to_sent;
    global $imapServerAddress, $imapPort, $sent_folder, $key, $use_htmlarea;
    global $squirrelmail_plugin_hooks;

    $book = addressbook_init(true, true);
    $abook = $book[0];
    $gabook = $book[1];

    if($abook->localbackend == 0) {
	plain_error_message(
    	    codeHTML(_("No personal address book is defined. Contact administrator.")),
    	    $color);
	exit();
    }
    $rfc822_header = $composeMessage->rfc822_header;
    if ($draft) {
	$rfc822_header->to = $rfc822_header->parseAddress($send_to,true, array(), '', $domain);
	$rfc822_header->cc = $rfc822_header->parseAddress($send_to_cc,true, array(), '', $domain);
	$rfc822_header->bcc = $rfc822_header->parseAddress($send_to_bcc,true, array(), '', $domain);
    } else {
	$rfc822_header->to = $rfc822_header->parseAddress($send_to,true, array(), '', $domain, array(&$abook,'lookup'));
	$rfc822_header->cc = $rfc822_header->parseAddress($send_to_cc,true,array(), '',$domain, array(&$abook,'lookup'));
	$rfc822_header->bcc = $rfc822_header->parseAddress($send_to_bcc,true, array(), '',$domain, array(&$abook,'lookup'));
    }
    $rfc822_header->priority = $mailprio;
    $rfc822_header->subject = $subject;
    $special_encoding='';
    if (strtolower($default_charset) == 'iso-2022-jp') {
        if (mb_detect_encoding($body) == 'ASCII') {
            $special_encoding = '8bit';
        } else {
            $body = mb_convert_encoding($body, 'JIS');
            $special_encoding = '7bit';
        }
    }
    $composeMessage->setBody($body);
    if (ereg("^([^@%/]+)[@%/](.+)$", $username, $usernamedata)) {
       $popuser = $usernamedata[1];
       $domain  = $usernamedata[2];
       unset($usernamedata);
    } else {
       $popuser = $username;
    }
    $reply_to = '';
    if (isset($identity) && $identity != 'default') {
        $from_mail = getPref($data_dir, $username,'email_address' . $identity);
        $full_name = getPref($data_dir, $username,'full_name' . $identity);
        $reply_to = getPref($data_dir, $username,'reply_to' . $identity);
    } else {
        $from_mail = getPref($data_dir, $username, 'email_address');
        $full_name = getPref($data_dir, $username, 'full_name');
        $reply_to = getPref($data_dir, $username,'reply_to');
    }
    if (!$from_mail) {
       $from_mail = "$popuser@$domain";
    }
    $rfc822_header->from = $rfc822_header->parseAddress($from_mail,true);
    if ($full_name) {
        $from = $rfc822_header->from[0];
        if (!$from->host) $from->host = $domain;
        $full_name_encoded = encodeHeader($full_name);
        if ($full_name_encoded != $full_name) {
            $from_addr = $full_name_encoded .' <'.$from->mailbox.'@'.$from->host.'>';
        } else {
            $from_addr = '"'.$full_name .'" <'.$from->mailbox.'@'.$from->host.'>';
        }
        $rfc822_header->from = $rfc822_header->parseAddress($from_addr,true);
    }
    if ($reply_to) {
       $rfc822_header->reply_to = $rfc822_header->parseAddress($reply_to,true);
    }
    /* Receipt: On Read */
    if (isset($request_mdn) && $request_mdn) {
       $rfc822_header->dnt = $rfc822_header->parseAddress($from_mail,true);
    }
    /* Receipt: On Delivery */
    if (isset($request_dr) && $request_dr) {
       $rfc822_header->more_headers['Return-Receipt-To'] = $from_mail;
    }
    /* multipart messages */
    if (count($composeMessage->entities)) {
        $message_body = new Message();
        $message_body->body_part = $composeMessage->body_part;
        $composeMessage->body_part = '';
        $mime_header = new MessageHeader;
        $mime_header->type0 = 'text';
	if ($use_htmlarea) { $mime_header->type1 = 'html'; }
	else { $mime_header->type1 = 'plain'; }
        if ($special_encoding) {
            $mime_header->encoding = $special_encoding;
        } else {
            $mime_header->encoding = '8bit';
        }
        if ($default_charset) {
            $mime_header->parameters['charset'] = $default_charset;
        }
        $message_body->mime_header = $mime_header;
        array_unshift($composeMessage->entities, $message_body);
        $content_type = new ContentType('multipart/mixed');
    } else {
	if ($use_hidden_htmlarea) { $content_type = new ContentType('text/html'); }
	else { $content_type = new ContentType('text/plain'); }
        if ($special_encoding) {
            $rfc822_header->encoding = $special_encoding;
        } else {
            $rfc822_header->encoding = '8bit';
        }
        if ($default_charset) {
            $content_type->properties['charset']=$default_charset;
	}
    }

    $rfc822_header->content_type = $content_type;
    $composeMessage->rfc822_header = $rfc822_header;

    if (!$draft && isset($squirrelmail_plugin_hooks['compose_send']) && is_array($squirrelmail_plugin_hooks['compose_send'])) {
	/* Here you can modify the message structure just before we hand
        it over to deliver */
	$hookReturn = do_hook_function('compose_send', array($composeMessage));
	/* Get any changes made by plugins to $composeMessage. */
	if ( is_object($hookReturn) ) { $composeMessage = $hookReturn; } else { return false; }
    }

    if (!$useSendmail && !$draft) {
        require_once(SM_PATH . 'class/deliver/Deliver_SMTP.class.php');
        $deliver = new Deliver_SMTP();
        global $smtpServerAddress, $smtpPort, $pop_before_smtp, $smtp_auth_mech;

        if ($smtp_auth_mech == 'none') {
                $user = '';
                $pass = '';
        } else {
                global $key, $onetimepad;
                $user = $username;
                $pass = OneTimePadDecrypt($key, $onetimepad);
        }

        $authPop = (isset($pop_before_smtp) && $pop_before_smtp) ? true : false;
        $stream = $deliver->initStream($composeMessage,$domain,0,
                          $smtpServerAddress, $smtpPort, $user, $pass, $authPop);
    } elseif (!$draft) {
       require_once(SM_PATH . 'class/deliver/Deliver_SendMail.class.php');
       global $sendmail_path;
       $deliver = new Deliver_SendMail();
       $stream = $deliver->initStream($composeMessage,$sendmail_path);
    } elseif ($draft) {
       global $draft_folder;
       require_once(SM_PATH . 'class/deliver/Deliver_IMAP.class.php');
       $imap_stream = sqimap_login($username, $key, $imapServerAddress,
                      $imapPort, 0);
       if (sqimap_mailbox_exists ($imap_stream, $draft_folder)) {
           require_once(SM_PATH . 'class/deliver/Deliver_IMAP.class.php');
           $imap_deliver = new Deliver_IMAP();
           $length = $imap_deliver->mail($composeMessage);
           sqimap_append ($imap_stream, $draft_folder, $length);
           $imap_deliver->mail($composeMessage, $imap_stream);
               sqimap_append_done ($imap_stream, $draft_folder);
           sqimap_logout($imap_stream);
           unset ($imap_deliver);
           return $length;
        } else {
	   $msg  = "\n".sprintf(_("Error: Draft folder %s does not exist."), $draft_folder);
           plain_error_message(codeHTML($msg), $color);
           return false;
        }
    }
    $succes = false;
    if ($stream) {
        $length = $deliver->mail($composeMessage, $stream);
        $succes = $deliver->finalizeStream($stream);
    }
    if (!$succes) {
        $msg  = $deliver->dlv_msg . "\n" .
                _("Server replied") .": ". $deliver->dlv_ret_nr . ' '.
                $deliver->dlv_server_msg;
        plain_error_message(codeHTML($msg), $color);
    } else {
        unset ($deliver);
        $move_to_sent = getPref($data_dir,$username,'move_to_sent');
        $imap_stream = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);

        /* Move to sent code */
        if (isset($default_move_to_sent) && ($default_move_to_sent != 0)) {
            $svr_allow_sent = true;
        } else {
            $svr_allow_sent = false;
        }

        if (isset($sent_folder) && (($sent_folder != '') || ($sent_folder != 'none'))
           && sqimap_mailbox_exists( $imap_stream, $sent_folder)) {
            $fld_sent = true;
        } else {
            $fld_sent = false;
        }

        if ((isset($move_to_sent) && ($move_to_sent != 0)) || (!isset($move_to_sent))) {
            $lcl_allow_sent = true;
        } else {
            $lcl_allow_sent = false;
        }

        if (($fld_sent && $svr_allow_sent && !$lcl_allow_sent) || ($fld_sent && $lcl_allow_sent)) {
            sqimap_append ($imap_stream, $sent_folder, $length);
            require_once(SM_PATH . 'class/deliver/Deliver_IMAP.class.php');
            $imap_deliver = new Deliver_IMAP();
            $imap_deliver->mail($composeMessage, $imap_stream);
            sqimap_append_done ($imap_stream, $sent_folder);
            unset ($imap_deliver);
        }
        global $passed_id, $mailbox, $action;
        ClearAttachments($composeMessage);
        if ($action == 'reply' || $action == 'reply_all') {
            sqimap_mailbox_select ($imap_stream, $mailbox);
            sqimap_messages_flag ($imap_stream, $passed_id, $passed_id, 'Answered', false);
        }
            sqimap_logout($imap_stream);
    }
    return $succes;
}

?>
