<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

define('SM_PATH','../');    

require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION );  
sqgetGlobalVar('sel',       $sel,           SQ_GET);

sqgetGlobalVar('public', $public, SQ_GET);
if (!$public) { sqgetGlobalVar('public', $public, SQ_POST); }
if (!$public) { $public = 0; }

sqgetGlobalVar('where', $where, SQ_GET);
if (!$where) { $where = "A"; }

$contacts = array();

$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];
if($gabook->localbackend == 0) {
    plain_error_message(
    	    codeHTML(_("No personal group addressbook is defined. Contact administrator.")),
    	    $color);
    exit();
} 

$alist = $gabook->list_addr(-1,1);

function alistcmpoverlookgroup($a,$b) {
    return (strtolower($a['group_name']) > strtolower($b['group_name'])) ? 1 : -1;
}

usort($alist,'alistcmpoverlookgroup');

if ($sel) {
    list($ebackend, $enick) = explode(':', $sel);
    if ($ebackend == 2) { $public = 1; }
    $data = $gabook->lookup_id($enick, $ebackend);
    $private_contacts = array();
    $public_contacts = array();
    if ($data['group_list_private']) {
	$private_contacts = $abook->lookup_group_id($data['group_list_private'], 1);
    }
    if ($data['group_list_public']) {
	$public_contacts = $abook->lookup_group_id($data['group_list_public'], 2);
    }
    $contacts = array_merge($public_contacts,$private_contacts);
}

displayHtmlHeader( _("Addressbook"), '' );

echo "\n".'<script language="JavaScript" type="text/javascript">document.folder_selected_old = 1</script>'."\n";
echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/addressbook_contact.js"></script>'."\n";
echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/edit_info_group.js"></script>'."\n";

    $id = 1;
    echo '<body onload="self.focus();">'."\n";
    echo '<table width="100%" height="100%" border=0 cellpadding=0 cellspacing=1 valign="top" align="left">';

	echo '<tr><td height="7%" valign="top">';
	    echo "\n<table height=\"100%\" cellpadding=\"2\" cellspacing=\"1\" border=\"0\">";
		echo "\n<tr>";
		    echo '<td class="nav" align="right">' . codeHTML(_('Show')). ': </td>';
		    for ($c=65; $c < 91; $c++) {
    			$cu = chr( $c );
    			/**contorno per lettera di ricerca selezionata*/
    			if ($where == $cu) {
        	    	    $selected="class=\"selected\"";
    			} else {
        		    $selected="class=\"nav\"";
    			}               
    			echo "\n\t<td nowrap=1 width=\"1%\" name=\"folder$id\"  id=\"folder$id\"  $selected><a onClick=\"SelectedLink($id,'$cu')\" href='#'>".codeHTML($cu)."</a></td>";
			$id++;
		    }
		    if ($where == 'number') {
    			$selected="class=\"selected\"";
		    } else {
    			$selected="class=\"nav\"";
		    }
		    echo '<td width="1%" nowrap=1 name="folder'.$id.'"  id="folder'.$id.'" '.$selected.'><a onClick="SelectedLink('.$id.',\'number\')" href="#">[0-9]</a></td>';
		    $id++;
		    if ($where == 'ALL') {
    			$selected="class=\"selected\"";
		    } else {
    			$selected="class=\"nav\"";
		    }
		    echo '<td width="1%" nowrap=1 name="folder'.$id.'"  id="folder'.$id.'" '.$selected.'><a onClick="SelectedLink('.$id.',\'ALL\')" href="#">' . codeHTML(_('All')) .'</a></td>';
		    $idall = $id;
		echo "\n</tr>";
	    echo "\n</table>";
	echo '</td></tr>';

	echo '<tr><td height="7%" valign="top">';
	    echo "\n<table height=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
		echo "\n<tr>";

		echo addForm($base_uri.'src/addressbook_popup_iframe_group.php', 'POST', 'ffilter','','','','ifabook');
		echo addHidden('where', $where);
		    echo '<td nowrap=1 width="1%" class="nav" align="left">'.codeHTML(_("Filters")).':</td>';
		    echo '<td nowrap=1 class="nav" align="left">';

		    $new_option = array();
		    $new_option['ALL'] = array('value' => _("All Addresses"), 'class' => 'privatecontact');
		    while(list($undef,$row) = each($alist)) {   
			if ($row['source'] == _("Global group address book")) {
			    $new_option['2;'.$row['group_id']] = array('value' => '[['.$row['group_name'].']]', 'class' => 'globalcontact');
			} else {
			    $new_option['1;'.$row['group_id']] = array('value' => '['.$row['group_name'].']', 'class' => 'privatecontact');
			}
		    }
		    echo addSelect('filter_group', $new_option, '', TRUE, 'onChange="document.ffilter.submit();" style="width:200px" size="1" id="filter_group"');
		echo '</td>';
		echo '</form>';

		echo addForm($base_uri.'src/addressbook_popup_iframe_group.php', 'POST', 'fsearch','','','','ifabook');
		echo addHidden('public', $public);
		echo addHidden('where', 'ALL');
		echo '<td nowrap=1 class="nav" align="right">';
		    echo addInput('nsearch', '', '', '', 'width="200px"');
		echo '</td>';
		echo '<td nowrap=1 width="1%" class="nav" align="right">';
		    echo addButton(_("Search All Addresses"), '', '','SelectedLink('.$idall.',"ALL",1); ','fsearch','',1);
		echo '</td>';
		echo '</form>';

		echo '</tr>';
	    echo '</table>';
	echo '</td></tr>';

	echo '<tr><td valign="top" width="100%" height="80%">';
	    echo '<table height="100%" width="100%" border=0 cellpadding=0 cellspacing=0 valign="top" align="left">';
		echo addForm($base_uri.'src/addressbook_group.php', 'POST', 'f');
		if ($public) { echo addHidden('newbackend', '2'); }
		if ($sel) { 
		    echo addHidden('sel', $sel);
		    echo addHidden('editgroup', '1');
		} else {
		    echo addHidden('addgroup', '1');
		}
		echo addHidden('group_list_public', '');
		echo addHidden('group_list_private', '');
		echo '<tr>';
		    echo '<td colspan=3 class="nav" height="1%">'.codeHTML(_("Group name:")).'&nbsp;';
			if ($sel) {
			    echo addInput('group_name', $data['group_name'], '', '30', 'width="200px"');
			} else {
			    echo addInput('group_name', '', '', '30', 'width="200px"');
			}
		    echo '</td>';
		echo '</tr>';
		echo '<tr>';
		    echo '<td colspan=3 class="nav" height="1%">'.codeHTML(_("Select contacts from the list:")).'</td>';
		echo '</tr>';
		echo '<tr>';
		    echo '<td width="35%" class="nav" valign="top">';
			echo '<iframe class="nav" name="ifabook" scrolling="no" frameborder="0" style="height:100%;width:100%" src="'.$base_uri.'src/addressbook_popup_iframe_group.php?public='.$public.'&where='.$where.'"></iframe>';
		    echo '</td>';
		    echo '<td class="nav">';
			echo '<table width="70%" border=0 cellpadding=3 class="border" cellspacing=0 valign="middle" align="center">';
			    echo '<tr>';
				echo '<td align="center" nowrap=1 class="nav" onclick="RemoveContact(\'group_el\');" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">&lt;--</td>';
				echo '<td align="center" nowrap=1 class="nav">&nbsp;</td>';
				echo '<td align="center" nowrap=1 class="nav" onclick="AddContact(\'group_el\',1);" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">--&gt;</td>';
			    echo '</tr>';
			echo '</table>';
		    echo '</td>';
		    echo '<td class="nav" width="35%" valign="top">';
			$new_option = array();
			if ($sel) { foreach ($contacts as $k => $v) { $new_option[$k] = $v; } }
			echo addSelect('group_el', $new_option, '', TRUE, 'multiple=1 style="width:98%;height:98%" id="group_el"');
		    echo '</td>';
		echo '</tr>';
	    echo '</table>';
	echo '</td></tr>';
	echo '<tr><td valign="top" width="100%" height="6%">';
	    echo '<table height="100%" width="100%" border=0 cellpadding=0 cellspacing=0 valign="top" align="left">';
		echo '<tr>';
		    echo '<td valign="middle" align="center" colspan=3 class="nav">';
			echo addButton(_("Cancel"), '', '', 'self.close()','f','',1,1);    
			echo '&nbsp;&nbsp;&nbsp;';
			echo addButton(_("Confirm"), '', '','','f','OnSubmit("'.jsspecialchars(_("Insert a group name")).'","'.jsspecialchars(_("Insert a contact")).'")');
		    echo '</td>';
		echo '</tr>';
		echo '</form>';
	    echo '</table>';
	echo '</td></tr>';
    echo '</table>';
echo '</body></html>';
?>