<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * folders_delete.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Deletes folders from the IMAP server. 
 * Called from the folders.php
 *
 * $Id: folders_delete.php,v 1.1 2004/02/02 14:00:12 marco Exp $
 */

global $squirrelmail_plugin_hooks;  

define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/tree.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/html.php');

/*
 *  Incoming values:
 *     $mailbox - selected mailbox from the form
 */

/* globals */
sqgetGlobalVar('key',       $key,           SQ_COOKIE);
sqgetGlobalVar('username',  $username,      SQ_SESSION);
sqgetGlobalVar('onetimepad',$onetimepad,    SQ_SESSION);
sqgetGlobalVar('base_uri',     $base_uri,      SQ_SESSION); 
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);
sqgetGlobalVar('subfolder',      $mailbox,          SQ_POST);
sqgetGlobalVar('subid',         $subid,     SQ_POST);  
/* end globals */


global $move_to_trash;

if ($mailbox == '') {
	plain_error_message(codeHTML(_("You have not selected a folder to delete. Please do so.")).
	    '<BR><A HREF="'.$base_uri.'src/folders.php">'.codeHTML(_("Click here to go back")).'</A>.', $color);
    exit;
}

if ( sqgetGlobalVar('backingout', $tmp, SQ_POST) ) {
	header ('Location: ' . $base_uri.'src/folders.php');  
    exit;
}

$imap_stream = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);

$boxes = sqimap_mailbox_list ($imap_stream);
$numboxes = count($boxes);

global $delete_folder;

if (substr($mailbox, -1) == $delimiter)
    $mailbox_no_dm = substr($mailbox, 0, strlen($mailbox) - 1);
else
    $mailbox_no_dm = $mailbox;

/** lets see if we CAN move folders to the trash.. otherwise,
    ** just delete them **/

// 1: rimuovo messaggi e sottocartelle
// 2: rimuovo messaggi e sottocartelle e sposto solo i messaggi
// 3: rimuovo messaggi e sottocartelle e sposto messaggi e sottocartelle
$can_move_to_trash = 3;

// se l'utente ha impostato di non avere il cestino
// e cerco di rimuovere la cartella non devo spostarla in
// trash ma cancellarla definitivamente
if (!$move_to_trash) {
    $can_move_to_trash = 1;
/* Courier IMAP doesn't like subfolders of Trash
 * If global options say we can't move it into Trash
 * If it's already a subfolder of trash, we'll have to delete it */
// se cerco di rimuovere una sottocartella di trash, non devo spostarla in
// trash ma cancellarla definitivamente
} else if ((isset($delete_folder) && $delete_folder) || eregi('^'.$trash_folder.'.+', $mailbox) ) {
    $can_move_to_trash = 1;
/* Otherwise, check if trash folder exits and support sub-folders */
// se courier imap e' settato per non consentire la creazione delle sottocartelle
// in trash, non posso crearle e quindi sposto solamente i messaggi in trash
} else {
    for ($i = 0; $i < $numboxes; $i++) {
        if ($boxes[$i]['unformatted'] == $trash_folder) {
	    if (in_array('noinferiors', $boxes[$i]['flags'])) {
		$can_move_to_trash = 2;
	    }
        }
    }
}

/** First create the top node in the tree **/
for ($i = 0; $i < $numboxes; $i++) {
    if (($boxes[$i]['unformatted-dm'] == $mailbox) && (strlen($boxes[$i]['unformatted-dm']) == strlen($mailbox))) {
        $foldersTree[0]['value'] = $mailbox;
        $foldersTree[0]['doIHaveChildren'] = false;
        continue;
    }
}

/* Now create the nodes for subfolders of the parent folder
   You can tell that it is a subfolder by tacking the mailbox delimiter
   on the end of the $mailbox string, and compare to that.  */
for ($i = 0; $i < $numboxes; $i++) {
    if (substr($boxes[$i]['unformatted'], 0, strlen($mailbox_no_dm . $delimiter)) == ($mailbox_no_dm . $delimiter)) {
        addChildNodeToTree($boxes[$i]["unformatted"], $boxes[$i]['unformatted-dm'], $foldersTree);
    }
}

// sposto sottocartelle e messaggi in trash
if ($can_move_to_trash == 3) {
    walkTreeInPostOrderCreatingFoldersUnderTrash(0, $imap_stream, $foldersTree, $mailbox);
// sposto in trash solo i messaggi
} else if ($can_move_to_trash == 2) {
    walkTreeInPostOrderMoveMessagesUnderTrash(0, $imap_stream, $foldersTree, $mailbox);
}
// in ogni caso (1,2,3) rimuovo i messaggi e le sottocartelle
walkTreeInPreOrderDeleteFolders(0, $imap_stream, $foldersTree);

/** Log out this session **/
sqimap_logout($imap_stream);

header ('Location: ' . $base_uri.'src/folders.php?success=delete&subid='.$subid);

?>
