<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/* user_special_mailboxes -- Version 0.1
 * By Robin Rainton <robin@rainton.com>
 * http://rainton.com/fun/freeware
 */

/* Path for SquirrelMail required files. */
define('SM_PATH', '../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'include/load_prefs.php');

/* get globals we may need */
sqgetGlobalVar('key', $key, SQ_COOKIE);
sqgetGlobalVar('username', $username, SQ_SESSION);
sqgetGlobalVar('data_dir', $data_dir, SQ_SESSION);
sqgetGlobalVar('base_uri',     $base_uri,      SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);
sqgetGlobalVar('subfolder',      $mailbox,          SQ_POST);
sqgetGlobalVar('subid',         $subid,     SQ_POST);
/* end globals */

if ($mailbox == '') {
        plain_error_message(codeHTML(_("You have not selected a folder to set/unset as special. Please do so.")).
            '<BR><A HREF="'.$base_uri.'src/folders.php">'.codeHTML(_("Click here to go back")).'</A>.', $color);
    exit;
}

if ( sqgetGlobalVar('backingout', $tmp, SQ_POST) ) {
        header ('Location: ' . $base_uri.'src/folders.php');
    exit;
}

if (substr_count($mailbox, $delimiter) > 1) {
        plain_error_message(codeHTML(_("You can set as special only first level folders")).
            '.<BR><A HREF="'.$base_uri.'src/folders.php">'.codeHTML(_("Click here to go back")).'</A>.', $color);
    exit;
}

// variabili di supporto
$folder_special = 1;
$boxnum = 0;

// se la cartella era speciale: unset special
while ($spec = getPref($data_dir, $username, 'user_special_mailboxes' . $boxnum)) {
    if ($spec == $mailbox) {
	removePref($data_dir, $username, 'user_special_mailboxes' . $boxnum);
	$folder_special = 0;
	break;
    }
    $boxnum++;
}

// se la cartella non era speciale: set special
if ($folder_special == 1) {
    setPref($data_dir, $username, 'user_special_mailboxes' . $boxnum, $mailbox);
}

if ($folder_special == 1) {
    header ('Location: ' . $base_uri.'src/folders.php?success=setspecial&subid='.$subid);
} else {
    header ('Location: ' . $base_uri.'src/folders.php?success=unsetspecial&subid='.$subid);
}

?>
