<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

define('SM_PATH','../');    

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/mime.php');
require_once(SM_PATH . 'functions/date.php');
require_once(SM_PATH . 'functions/url_parser.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/forms.php');

displayHtmlHeader( '', '' );

/* get the globals we may need */
 
sqgetGlobalVar('key',       $key,           SQ_COOKIE);
sqgetGlobalVar('username',  $username,      SQ_SESSION);
sqgetGlobalVar('onetimepad',$onetimepad,    SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);
sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);
 
sqgetGlobalVar('msgs',      $msgs,          SQ_SESSION);
sqgetGlobalVar('msort',     $msort,         SQ_SESSION);
sqgetGlobalVar('lastTargetMailbox', $lastTargetMailbox, SQ_SESSION);
sqgetGlobalVar('server_sort_array', $server_sort_array, SQ_SESSION);
if (!sqgetGlobalVar('messages', $messages, SQ_SESSION) ) {
    $messages = array();
}
 
/** GET VARS */
sqgetGlobalVar('sendreceipt',   $sendreceipt,   SQ_GET);
sqgetGlobalVar('where',         $where,         SQ_GET);
sqgetGlobalVar('what',          $what,          SQ_GET);
if ( sqgetGlobalVar('show_more', $temp,  SQ_GET) ) {
    $show_more = (int) $temp;
}
if ( sqgetGlobalVar('show_more_cc', $temp,  SQ_GET) ) {
    $show_more_cc = (int) $temp;
}
if ( sqgetGlobalVar('show_more_bcc', $temp,  SQ_GET) ) {
    $show_more_bcc = (int) $temp;
}
if ( sqgetGlobalVar('view_hdr', $temp,  SQ_GET) ) {
    $view_hdr = (int) $temp;
}
 
/** POST VARS */
sqgetGlobalVar('move_id',       $move_id,       SQ_POST);

/** GET/POST VARS */
sqgetGlobalVar('passed_ent_id', $passed_ent_id);
sqgetGlobalVar('mailbox',       $mailbox);
 
if ( sqgetGlobalVar('passed_id', $temp) ) {
    $passed_id = (int) $temp;
}
if ( sqgetGlobalVar('sort', $temp) ) {
    $sort = (int) $temp;
}
if ( sqgetGlobalVar('startMessage', $temp) ) {
    $startMessage = (int) $temp;
}
 
/* end of get globals */
global $uid_support, $sqimap_capabilities;

$imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);
$mbx_response   = sqimap_mailbox_select($imapConnection, $mailbox, false, false, true);

$uidvalidity = $mbx_response['UIDVALIDITY'];
 
if (!isset($messages[$uidvalidity])) {
   $messages[$uidvalidity] = array();
}
if (!isset($messages[$uidvalidity][$passed_id]) || !$uid_support) {
   $message = sqimap_get_message($imapConnection, $passed_id, $mailbox);
   $FirstTimeSee = !$message->is_seen;
   $message->is_seen = true;
   $messages[$uidvalidity][$passed_id] = $message;
} else {
//   $message = sqimap_get_message($imapConnection, $passed_id, $mailbox);
   $message = $messages[$uidvalidity][$passed_id];
   $FirstTimeSee = !$message->is_seen;
}
 
if (isset($passed_ent_id) && $passed_ent_id) {
   $message = $message->getEntity($passed_ent_id);
   if ($message->type0 != 'message'  && $message->type1 != 'rfc822') {
      $message = $message->parent;
   }
   $read = sqimap_run_command ($imapConnection,"FETCH $passed_id BODY[$passed_ent_id.HEADER]", true, $response, $msg, $uid_support);
   $rfc822_header = new Rfc822Header();
   $rfc822_header->parseHeader($read);
   $message->rfc822_header = $rfc822_header;
} else {
   $passed_ent_id = 0;
}
$header = $message->header;

if ($show_html_default == 1) {
    $ent_ar = $message->findDisplayEntity(array());
} else {
    $ent_ar = $message->findDisplayEntity(array(), array('text/plain'));
}

function formatAttachmentsoverlook($message, $exclude_id, $mailbox, $id) {
    global $where, $what, $startMessage, $color, $base_uri;
    static $ShownHTML = 0;

    $att_ar = $message->getAttachments($exclude_id);

    if (!count($att_ar)) return '';

    $attachments = '';

    $urlMailbox = urlencode($mailbox);
    foreach ($att_ar as $att) {
        $ent = $att->entity_id;
        $header = $att->header;
        $type0 = strtolower($header->type0);
        $type1 = strtolower($header->type1);
        $name = '';
        $links['download link']['text'] = codeHTML(_("download"));
        $links['download link']['href'] = $base_uri .
                "src/download.php?absolute_dl=true&passed_id=$id&mailbox=$urlMailbox&ent_id=$ent";
        $ImageURL = '';
        if ($type0 =='message' && $type1 == 'rfc822') {
    	    $default_page = $base_uri . 'src/read_body.php';
            $rfc822_header = $att->rfc822_header;
            $filename = $rfc822_header->subject;
            if (trim( $filename ) == '') {
                $filename = 'untitled-[' . $ent . ']';
            }
            $from_o = $rfc822_header->from;
            if (is_object($from_o)) {
                $from_name = $from_o->getAddress(false);
            } else {
                $from_name = _("Unknown sender");
            }
            $from_name = decodeHeader(($from_name));
            $description = $from_name;
        } else {
    	    $default_page = $base_uri . 'src/download.php';
            if (is_object($header->disposition)) {
                $filename = $header->disposition->getProperty('filename');
                if (trim($filename) == '') {
                    $name = decodeHeader($header->disposition->getProperty('name'));
                    if (trim($name) == '') {
                        $name = $header->getParameter('name');
                        if(trim($name) == '') {
                            if (trim( $header->id ) == '') {
                                $filename = 'untitled-[' . $ent . ']' ;
                            } else {
                                $filename = 'cid: ' . $header->id;
                            }
                        } else {
                            $filename = $name;
                        }
                    } else {
                        $filename = $name;
                    }
                }
            } else {
                $filename = $header->getParameter('name');
                if (!trim($filename)) {
                    if (trim( $header->id ) == '') {
                        $filename = 'untitled-[' . $ent . ']' ;
                    } else {
                        $filename = 'cid: ' . $header->id;
                    }
                }
            }
            if ($header->description) {
                $description = decodeHeader($header->description);
            } else {
                $description = '';
            }
        }
        $display_filename = $filename;
        if (isset($passed_ent_id)) {
            $passed_ent_id_link = '&passed_ent_id='.$passed_ent_id;
        } else {
            $passed_ent_id_link = '';
        }
        $defaultlink = $default_page . "?startMessage=$startMessage"
                     . "&passed_id=$id&mailbox=$urlMailbox"
                     . '&ent_id='.$ent.$passed_ent_id_link;
        if ($where && $what) {
           $defaultlink .= '&where='. urlencode($where).'&what='.urlencode($what);
        }
	$defaultlink = 'location.href="'.$defaultlink.'"';
        /* This executes the attachment hook with a specific MIME-type.
         * If that doesn't have results, it tries if there's a rule
         * for a more generic type.
         */
	// se si vuole abilitare la visione di altri messaggi bisogna
	// modificare questo if: (es message/rfc822) e creare il relativo plugin!

	$hookresults = do_hook("attachment $type0/$type1", $links,
                               $startMessage, $id, $urlMailbox, $ent, $defaultlink,
                               $display_filename, $where, $what);
        if(count($hookresults[1]) <= 1) {
            $hookresults = do_hook("attachment $type0/*", $links,
                                   $startMessage, $id, $urlMailbox, $ent, $defaultlink,
                                   $display_filename, $where, $what);
        }
        if ($hookresults[6]) { $defaultlink = $hookresults[6]; }
	if ("$type0/$type1" == "application/ms-tnef") {
	    $visual_filename = codeHTML(_("View content")).":&nbsp;".decodeHeader($display_filename);
	} 
	else if ("$type0/$type1" == "message/rfc822") {
	    $visual_filename = codeHTML(_("View message")).":&nbsp;".decodeHeader($display_filename);
	}
	else {
	    $visual_filename = decodeHeader($display_filename);
	}

        $attachments .= '<TR>
			<TD width="80%" class="nav" onclick=\''.$defaultlink.';\' onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">
                        '.$visual_filename.'</TD>
                        <TD width="20%" class="navevidenced">' . show_readable_size($header->size)
                        .'</TD></TR>';
    }
    if (count($att_ar) >= 1 && function_exists('gzcompress')) {
	$attachments .= "<tr height='1%'>
	    <td width='100%' onclick='location.href=\"" . $base_uri . "plugins/download_all/zipit.php?startMessage=$startMessage&mailbox=$mailbox&passed_id=$id\";' onmouseover=\"this.className='navclicked'\" colspan=2 onmouseout=\"this.className='nav'\" class='nav' align=\"center\">
		".codeHTML(_("Download All"))."
	    </td>";
    }
    return $attachments;
}

echo '<body onload="self.focus();">';

$attachmentsdisplay = formatAttachmentsoverlook($message,$ent_ar,$mailbox, $passed_id);
if ($attachmentsdisplay) {
   echo '<table height="100%" width="100%" cellpadding="2" cellspacing="1" align="center"'.' border="0">
	    <tr height="1%">
		<td class="navevidenced" align="left" valign="middle" width="80%" valign="top">
		    ' . codeHTML(_("Download attachments")) . ':
		</td>
		<td width="20%" class="nav" onClick="self.close();" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" align="center">
		    '.codeHTML(_("Close")).'
		</td>	
	    </tr>
	    '.$attachmentsdisplay.'
	</table>';
}

sqimap_logout($imapConnection);
/* sessions are written at the end of the script. it's better to register
   them at the end so we avoid double session_register calls */
sqsession_register($messages,'messages');

echo '</body></html>';
?>