<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * options_order.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Displays messagelist column order options
 *
 * $Id: options_order.php,v 1.2 2004/02/25 15:02:08 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/plugin.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');
require_once(SM_PATH . 'functions/options.php');

/* get globals */
sqgetGlobalVar('num',       $num,       SQ_GET);  
sqgetGlobalVar('add',       $add,       SQ_GET);

sqgetGlobalVar('submit',    $submit);
sqgetGlobalVar('method',    $method,	SQ_GET);

global $custom_css;

sqgetGlobalVar('base_uri', $base_uri,     SQ_SESSION);
$optpage_name = _("Indexes");

    $available[1] = _("Checkbox");
    $available[2] = _("From");
    $available[3] = _("Date");
    $available[4] = _("Subject");
    $available[5] = _("Flags");
    $available[6] = _("Size");
    $available[7] = _("Priority");
    $available[8] = _("Attach");
    
    if (! isset($method)) { $method = ''; }
 
    if ($method == 'up' && $num > 1) {
        $prev = $num-1;
        $tmp = $index_order[$prev];
        $index_order[$prev] = $index_order[$num];
        $index_order[$num] = $tmp;
    } else if ($method == 'down' && $num < count($index_order)) {
        $next = $num++;
        $tmp = $index_order[$next];
        $index_order[$next] = $index_order[$num];
        $index_order[$num] = $tmp;
    } else if ($method == 'remove' && $num) {
        for ($i=1; $i <= count($available); $i++) {
            removePref($data_dir, $username, "order$i"); 
        }
        for ($j=1,$i=1; $i <= count($index_order); $i++) {
           if ($i != $num) {
               $new_ary[$j] = $index_order[$i];
               $j++;
           }
        }
        $index_order = array();
        $index_order = $new_ary;
        if (count($index_order) < 1) {
           include_once($base_uri.'src/load_prefs.php');
        }
    } else if ($method == 'add' && $add) {
        /* User should not be able to insert PHP-code here */
        $add = str_replace ('<?', '..', $add);
        $add = ereg_replace ('<.*script.*language.*php.*>', '..', $add);
        $add = str_replace ('<%', '..', $add);
        $index_order[count($index_order)+1] = $add;
    }
 
    if ($method) {
        for ($i=1; $i <= count($index_order); $i++) {
           setPref($data_dir, $username, "order$i", $index_order[$i]);
        }
    }

displayHtmlHeader(_("Options - Indexes"));
echo '<body onload="self.focus();">';
echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/tips.js"></script>';
echo '<table class="border" width="100%" height="100%" cellpadding="0" cellspacing="0" border="0">';

ShowOptionBar(); 

echo '<tr>
	<td align="left" width="100%" height="100%">
	    <table class="border" width="100%" height="100%" align="center" valign="top" cellpadding="10" cellspacing="2" border="0">
		<tr height="1%">
		    <td colspan=4 align="center" valign="middle" width="100%" class="nav">
			'.codeHTML(_("The index order is the order that the columns are arranged in the message index.  You can add, remove, and move columns around to customize them to fit your needs.")).'
		    </td>
    		</tr>';
 
    if (count($index_order))
    {
        for ($i=1; $i <= count($index_order); $i++) {
            $tmp = $index_order[$i];
	    if ($i != 1) {
		echo '<tr height="1%">
		    <td width="10%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'src/options_order.php?method=up&num='.$i.'\'" valign="middle" align="center" class="nav">
			<img alt="'._("Move up").'" border=0 src="'.$base_uri.'images/'.$custom_css.'/up_pointer.png">			
		    </td>';
	    } else {
		echo '<tr height="1%">
			<td width="10%" valign="middle" align="center" class="nav">
			&nbsp;
		    </td>';
	    }
	    if ($i != count($index_order)) {
		echo '<td width="10%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'src/options_order.php?method=down&num='.$i.'\'" valign="middle" align="center" class="nav">
			<img alt="'._("Move down").'" border=0 src="'.$base_uri.'images/'.$custom_css.'/down_pointer.png">			
		    </td>';
	    } else {
		echo '<td width="10%" valign="middle" align="center" class="nav">
			&nbsp;
		    </td>';
	    }
            /* Always show the subject */
            if ($tmp != 4) {
		echo '<td width="10%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'src/options_order.php?method=remove&num='.$i.'\'" valign="middle" align="center" class="nav">
			'.codeHTML(_("remove")).'			
		    </td>';
	    } else {
		echo '<td width="10%" valign="middle" align="center" class="nav">
			&nbsp;
		    </td>';
	    }
	    echo '<td valign="middle" align="center" class="nav">
			'.codeHTML($available[$tmp]).'
		    </td>';
	    echo '</tr>';
        }
    }
    if (count($index_order) != count($available)) {
	for ($i=1; $i <= count($available); $i++) {
	    $found = false;
    	    for ($j=1; $j <= count($index_order); $j++) {
        	if ($index_order[$j] == $i) {
            	    $found = true;
        	}
    	    }
    	    if (!$found) {
		echo '<tr height="1%">
		    <td width="10%" valign="middle" align="center" class="nav">
			&nbsp;			
		    </td>
		    <td width="10%" valign="middle" align="center" class="nav">
			&nbsp;			
		    </td>';
		    echo '<td width="10%" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="document.location.href=\''.$base_uri.'src/options_order.php?method=add&add='.$i.'\'" valign="middle" align="center" class="nav">
			'.codeHTML(_("add")).'			
		    </td>';
		    echo '<td valign="middle" align="center" class="nav">
			    '.codeHTML($available[$i]).'
			</td>';
		echo '</tr>';
    	    }
	}
    }	
echo '<tr><td colspan=4 width="100%" class="nav">&nbsp;</td></tr>';
echo '</table></td></tr>';     
echo '</table>';
echo $echotips;  
echo '</body></html>';

?>