<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * printer_friendly_bottom.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * with javascript on, it is the bottom frame of printer_friendly_main.php
 * else, it is alone in a new window
 *
 * - this is the page that does all the work, really.
 *
 * $Id: printer_friendly_bottom.php,v 1.2 2004/02/25 15:02:08 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'config/config.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/global.php');

/* get some of these globals */
sqgetGlobalVar('username', $username, SQ_SESSION);
sqgetGlobalVar('key', $key, SQ_COOKIE);
sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);

sqgetGlobalVar('passed_id', $passed_id);
sqgetGlobalVar('mailbox', $mailbox);

if (! sqgetGlobalVar('passed_ent_id', $passed_ent_id) ) {
    $passed_ent_id = '';
} 
/* end globals */

$pf_cleandisplay = getPref($data_dir, $username, 'pf_cleandisplay');
$imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);
$mbx_response = sqimap_mailbox_select($imapConnection, $mailbox);
if (isset($messages[$mbx_response['UIDVALIDITY']][$passed_id])) {
    $message = &$messages[$mbx_response['UIDVALIDITY']][$passed_id];
} else {
    $message = sqimap_get_message($imapConnection, $passed_id, $mailbox);
}
if ($passed_ent_id) {
    $message = &$message->getEntity($passed_ent_id);
}

/* --start display setup-- */

$rfc822_header = $message->rfc822_header; 
/* From and Date are usually fine as they are... */
$from = $rfc822_header->getAddr_s('from');
$date = getLongDateString($rfc822_header->date);
$subject = trim($rfc822_header->subject);

/* we can clean these up if the list is too long... */
$cc = $rfc822_header->getAddr_s('cc');
$bcc = $rfc822_header->getAddr_s('bcc');
$to = $rfc822_header->getAddr_s('to');

$mailprio = $rfc822_header->priority;
// priority
if(!isset($mailprio)) { $mailprio = "3"; }

if ($show_html_default == 1) {
    $ent_ar = $message->findDisplayEntity(array());
} else {
    $ent_ar = $message->findDisplayEntity(array(), array('text/plain'));
}
$body = '';
if ($ent_ar[0] != '') {
  for ($i = 0; $i < count($ent_ar); $i++) {
     $body .= formatBody($imapConnection, $message, $color, $wrap_at, $ent_ar[$i], $passed_id, $mailbox);
  }
} else {
  $body = codeHTML(_("Message not printable"));
}

 /* now, if they choose to, we clean up the display a bit... */
 

if ( empty($pf_cleandisplay) || $pf_cleandisplay != 'no' ) {

    $num_leading_spaces = 9; // nine leading spaces for indentation

     // sometimes I see ',,' instead of ',' seperating addresses *shrug*
//    $cc = pf_clean_string(str_replace(',,', ',', $cc), $num_leading_spaces);
//    $to = pf_clean_string(str_replace(',,', ',', $to), $num_leading_spaces);

     // the body should have no leading zeros
    // disabled because it destroys html mail
    // questa funzione e' stata commentata per incompatibilita' con funzione
    // che crea i links sulle email
    //$body = pf_clean_string($body, 0);

     // clean up everything else...
//    $subject = pf_clean_string($subject, $num_leading_spaces);
//    $from = pf_clean_string($from, $num_leading_spaces);
//    $date = pf_clean_string($date, $num_leading_spaces);

} // end cleanup

$to = decodeHeader($to);
$cc = decodeHeader($cc);
$bcc = decodeHeader($bcc);
$from = decodeHeader($from);

$subject = decodeHeader($subject);
$subject = decodeHTML($subject);
$subject = processSubject($subject, 0,$max_char_obj_d);
$subject = codeHTML($subject);

// --end display setup--


/* --start browser output-- */
displayHtmlHeader( $subject, '', FALSE );

echo '<body onload="self.focus();">';
echo '<table class="border" width="100%" height="100%" align="center" cellspacing=2 cellpadding=3 border=0 valign="top">' . "\n";
    echo '<tr height="1%">';
    if ($mailprio == 1) {
        echo '<td id="td_priority" colspan=2 align="left"  width="100%" class="priorityhigh">'.codeHTML(_("The message has high priority")).'</td>';
    } else if ($mailprio == 3) {
        echo '<td id="td_priority" colspan=2 align="left"  width="100%" class="prioritynormal">'.codeHTML(_("The message has normal priority")).'</td>';
    } else if ($mailprio == 5) {
        echo '<td id="td_priority" colspan=2 align="left"  width="100%" class="prioritylow">'.codeHTML(_("The message has low priority")).'</td>';
    }
    echo '</tr>';
    echo '<tr height="1%">';
    	echo '<td align="left"  class="nav" width="10%">'.codeHTML(_("From:")).'</td>';
	if (!$from) { $from = "&nbsp;"; }
    	echo '<td align="left"  class="border" width="90%">'.$from.'</td>';
    echo '</tr>';																							                    
    echo '<tr height="1%">';
    	echo '<td align="left"  class="nav" width="10%">'.codeHTML(_("To:")).'</td>';
	if (!$to) { $to = "&nbsp;"; }
    	echo '<td align="left"  class="border" width="90%">'.$to.'</td>';
    echo '</tr>';
    if ( strlen($cc) > 0 ) { /* only show CC: if it's there... */
	if (!$cc) { $cc = "&nbsp;"; }
	echo '<tr height="1%">';
    	    echo '<td align="left"  class="nav" width="10%">'.codeHTML(_("CC:")).'</td>';
    	    echo '<td align="left"  class="border" width="90%">'.$cc.'</td>';
	echo '</tr>';																							                    
    }
    if ( strlen($bcc) > 0 ) { /* only show CC: if it's there... */
	if (!$bcc) { $bcc = "&nbsp;"; }
	echo '<tr height="1%">';
    	    echo '<td align="left"  class="nav" width="10%">'.codeHTML(_("BCC:")).'</td>';
    	    echo '<td align="left"  class="border" width="90%">'.$bcc.'</td>';
	echo '</tr>';																							                    
    }
    echo '<tr height="1%">';
	$date = codeHTML($date);
	if (!$date) { $date = "&nbsp;"; }
    	echo '<td align="left"  class="nav" width="10%">'.codeHTML(_("Date:")).'</td>';
    	echo '<td align="left"  class="border" width="90%">'.$date.'</td>';
    echo '</tr>';
    echo '<tr height="1%">';
    	echo '<td align="left"  class="nav" width="10%">'.codeHTML(_("Subject:")).'</td>';
	if (!$subject) { $subject = "&nbsp;"; }
    	echo '<td align="left"  class="border" width="90%">'.$subject.'</td>';
    echo '</tr>';
    echo '<tr>';
    	echo '<td valign="top" align="left" colspan=2 class="border" width="100%" height="1%">';
	    echo '<table width="100%" align="center" cellspacing=1 cellpadding=1 border=0 valign="top" height="1%">' . "\n";
		echo '<tr><td>';
		    echo $body;
		echo '</td></tr>';
	    echo '</table>';
        echo '</td>';
    echo '</tr>';
    echo '<tr height="1%">';
    	echo '<td height="1%" valign="top" align="left" colspan=2 class="border" width="100%">';
	    do_hook('friendly_body_bottom');   
	echo '</td>';
    echo '</tr>';
echo '</table>';
echo '</body></html>';    
																									                    
/* --end browser output-- */


/* --start pf-specific functions-- */

/* $string = pf_clean_string($string, 9); */
function pf_clean_string ( $unclean_string, $num_leading_spaces ) {
    global $data_dir, $username;
    $unclean_string = str_replace('&nbsp;',' ',$unclean_string);
    $wrap_at = getPref($data_dir, $username, 'wrap_at', 86);
    $wrap_at = $wrap_at - $num_leading_spaces; /* header stuff */

    $leading_spaces = '';
    while ( strlen($leading_spaces) < $num_leading_spaces )
        $leading_spaces .= ' ';

    $clean_string = '';
    while ( strlen($unclean_string) > $wrap_at )
    {
        $this_line = substr($unclean_string, 0, $wrap_at);
        if ( strrpos( $this_line, "\n" ) ) /* this should NEVER happen with anything but the $body */
        {
            $clean_string .= substr( $this_line, 0, strrpos( $this_line, "\n" ));
            $clean_string .= $leading_spaces;
            $unclean_string = substr($unclean_string, strrpos( $this_line, "\n" ));
        }
        else
        {
	    $i = strrpos( $this_line, ' ');
    	    $clean_string .= substr( $this_line, 0, $i);
    	    $clean_string .= "\n" . $leading_spaces;
    	    $unclean_string = substr($unclean_string, 1+$i);
	}
    }
    $clean_string .= $unclean_string;

    return $clean_string;
} /* end pf_clean_string() function */

/* --end pf-specific functions */

?>
