<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * read_body.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file is used for reading the msgs array and displaying
 * the resulting emails in the right frame.
 *
 * $Id: read_body.php,v 1.5 2004/02/09 08:55:26 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');


/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/mime.php');
require_once(SM_PATH . 'functions/date.php');
require_once(SM_PATH . 'functions/mailbox_display.php');
require_once(SM_PATH . 'functions/url_parser.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/read_body_functions.php');

sqgetGlobalVar('HTTP_USER_AGENT', $HTTP_USER_AGENT, SQ_SERVER);

//non visualizza il messaggio in pagina principale se l'opzione e' settata a 0
global $view_read_body_main_page, $custom_css;
if (!$view_read_body_main_page) { exit; }

/***************************/
/*   Main of read_body.php */
/***************************/

/* get the globals we may need */

sqgetGlobalVar('key',       $key,           SQ_COOKIE);
sqgetGlobalVar('username',  $username,      SQ_SESSION);
sqgetGlobalVar('onetimepad',$onetimepad,    SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);
sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);

sqgetGlobalVar('msgs',      $msgs,          SQ_SESSION);
sqgetGlobalVar('msort',     $msort,         SQ_SESSION);
sqgetGlobalVar('lastTargetMailbox', $lastTargetMailbox, SQ_SESSION);
sqgetGlobalVar('server_sort_array', $server_sort_array, SQ_SESSION);
if (!sqgetGlobalVar('messages', $messages, SQ_SESSION) ) {
    $messages = array();
}

/** GET VARS */
sqgetGlobalVar('sendreceipt',   $sendreceipt,   SQ_GET);
sqgetGlobalVar('where',         $where,         SQ_GET);
sqgetGlobalVar('what',          $what,          SQ_GET);
if ( sqgetGlobalVar('show_more', $temp,  SQ_GET) ) {
    $show_more = (int) $temp;
}
if ( sqgetGlobalVar('show_more_cc', $temp,  SQ_GET) ) {
    $show_more_cc = (int) $temp;
}
if ( sqgetGlobalVar('show_more_bcc', $temp,  SQ_GET) ) {
    $show_more_bcc = (int) $temp;
}
if ( sqgetGlobalVar('view_hdr', $temp,  SQ_GET) ) {
    $view_hdr = (int) $temp;
}

/** POST VARS */
sqgetGlobalVar('move_id',       $move_id,       SQ_POST);

/** GET/POST VARS */
sqgetGlobalVar('passed_ent_id', $passed_ent_id);
sqgetGlobalVar('mailbox',       $mailbox);

if ( sqgetGlobalVar('passed_id', $temp) ) {
    $passed_id = (int) $temp;
}
if ( sqgetGlobalVar('sort', $temp) ) {
    $sort = (int) $temp;
}
if ( sqgetGlobalVar('startMessage', $temp) ) {
    $startMessage = (int) $temp;
}

if ( sqgetGlobalVar('PG_SHOWNUM', $temp) ) {
  $show_num = (int) $temp;
}

/* end of get globals */
global $uid_support, $sqimap_capabilities, $custom_css;

if (isset($passed_id) && $passed_id) {
    $imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);
    $mbx_response   = sqimap_mailbox_select($imapConnection, $mailbox, false, false, true);

    /**
     * $message contains all information about the message
     * including header and body
     */

    $uidvalidity = $mbx_response['UIDVALIDITY'];

    if (!isset($messages[$uidvalidity])) {
	$messages[$uidvalidity] = array();
    }
    if (!isset($messages[$uidvalidity][$passed_id]) || !$uid_support) {
	$message = sqimap_get_message($imapConnection, $passed_id, $mailbox);
	if ($message) {
	    $FirstTimeSee = !$message->is_seen;
	    $message->is_seen = true;
	    $messages[$uidvalidity][$passed_id] = $message;
	}
    } else {
	$message = $messages[$uidvalidity][$passed_id];
	if ($message) {
	    $FirstTimeSee = !$message->is_seen;
	}
    }
}


if (!isset($message)) {
    displayHtmlHeader( '', '' );
	echo "<script language='javascript'>
		    var priotext = '".jsspecialchars(_("Header"))."';
		    var custom_css = '".$custom_css."';
		</script>\n";
	echo '<BODY onload="parent.ChangeText()">';
	echo '<table align="center" width="100%" height="1%" valign="top" cellpadding=0 cellspacing=0 border=0>';
	echo '<tr><td align="center" class="nav">';
	echo '&nbsp;';
	echo '</td></tr>';
	echo '</table>';
	echo '<div id="mail_h" name="mail_h" style="position:relative;z-index:2;width:100%;height:20%;top:0;left:0;margin-top:0;margin-left:0;margin-right:0;margin-bottom:0;">';
	    echo '<table class="titlemsg" valign="top" align="center" width="100%" height="100%"><tr><td>&nbsp;</td></tr></table>';
	echo '</div>';
	echo '<div id="menu_bar" style="position:relative;z-index:2;width:100%;height:8%;top:0;left:0;margin-top:0;margin-left:0;margin-right:0;margin-bottom:0;">';
	    echo '<table class="titlemsg" valign="top" align="center" width="100%" height="100%"><tr><td>&nbsp;</td></tr></table>';
	echo '</div>';
	echo '<DIV id="body_msg" name="body_msg" style="position:relative;z-index:2;top:0;left:0;width:100%;height:80%;overflow:scroll;margin-top:0;margin-left:0;margin-right:0;margin-bottom:0;">';
	echo '<TABLE width="100%" align="center" border=0 cellspacing=0 cellpadding=0>'; 
    	    echo html_tag( 'tr',
                html_tag( 'td',
                          "<BR><b>" . codeHTML(_("NO MESSAGE SELECTED")) . "</b><BR>&nbsp;",
                          'center',
                          $color[4],
                          'COLSPAN="' . count($index_order) . '"'
                )
    	    );
	echo '</table>';
	echo '</div>';

    echo '</body></html>';	
    exit;
}

if (isset($passed_ent_id) && $passed_ent_id) {
   $message = $message->getEntity($passed_ent_id);
   if ($message->type0 != 'message'  && $message->type1 != 'rfc822') {
      $message = $message->parent;
   }
   $read = sqimap_run_command ($imapConnection, "FETCH $passed_id BODY[$passed_ent_id.HEADER]", true, $response, $msg, $uid_support);
   $rfc822_header = new Rfc822Header();
   $rfc822_header->parseHeader($read);
   $message->rfc822_header = $rfc822_header;
} else {
   $passed_ent_id = 0;
}
$header = $message->header;

/****************************************/
/* Block for handling incoming url vars */
/****************************************/

if (isset($sendreceipt)) {
   if ( !$message->is_mdnsent ) {
      if (isset($identity) ) {
	 $final_recipient = getPref($data_dir, $username, 'email_address0', '' );
      } else {
         $final_recipient = getPref($data_dir, $username, 'email_address', '' );
      }

      $final_recipient = trim($final_recipient);
      if ($final_recipient == '' ) {
         $final_recipient = getPref($data_dir, $username, 'email_address', '' );
      }
      $supportMDN = ServerMDNSupport($mbx_response["PERMANENTFLAGS"]);
      if ( SendMDN( $mailbox, $passed_id, $final_recipient, $message, $imapConnection ) > 0 && $supportMDN ) {
         ToggleMDNflag( true, $imapConnection, $mailbox, $passed_id, $uid_support);
         $message->is_mdnsent = true;
         $messages[$uidvalidity][$passed_id]=$message;
      }
      ClearAttachments();
   }
}
/***********************************************/
/* End of block for handling incoming url vars */
/***********************************************/

$msgs[$passed_id]['FLAG_SEEN'] = true;

$messagebody = '';

if ($show_html_default == 1) {
    $ent_ar = $message->findDisplayEntity(array());
} else {
    $ent_ar = $message->findDisplayEntity(array(), array('text/plain'));
}
$cnt = count($ent_ar);
for ($i = 0; $i < $cnt; $i++) {
   $messagebody .= formatBody($imapConnection, $message, $color, $wrap_at, $ent_ar[$i], $passed_id, $mailbox);
   if ($i != $cnt-1) {
       $messagebody .= '<hr noshade size=1>';
   }
}
    displayHtmlHeader( '' );
	echo "<script language='javascript'>
		    var priotext = '".jsspecialchars(_("Header"))."';
		    var custom_css = '".$custom_css."';
		</script>\n";
	echo '<BODY onload="parent.ChangeText()">';
    echo '<table align="center" width="100%" height="1%" valign="top" cellpadding=0 cellspacing=0 border=0>';
    echo '<tr><td align="center" class="nav">';
    echo '<a href="#" onClick="parent.MoveFrameset(0)"><img id="imgmoveup" src="'.$base_uri.'images/'.$custom_css.'/up_toggle.png" border=0></a>';
    echo '<a href="#" onClick="parent.MoveFrameset(1)"><img id="imgmovedown" src="'.$base_uri.'images/'.$custom_css.'/down_toggle.png" border=0></a>';
    echo '</td></tr>';
    echo '</table>';
    echo '<div id="mail_h" name="mail_h" style="position:relative;z-index:2;width:100%;height:20%;top:0;left:0;margin-top:0;margin-left:0;margin-right:0;margin-bottom:0;">';
	formatEnvheader($mailbox, $passed_id, $passed_ent_id, $message, $color, $FirstTimeSee);
    echo '</div>';
    echo '<div id="menu_bar" style="position:relative;z-index:2;width:100%;height:8%;top:0;left:0;margin-top:0;margin-left:0;margin-right:0;margin-bottom:0;">';
	formatMenuBar($mailbox, $passed_id, $passed_ent_id, $message, $mbx_response,0,0,$show_num);
    echo '</div>';
    echo '<DIV id="body_msg" name="body_msg" style="position:relative;z-index:2;top:0;left:0;width:100%;height:68%;vertical-align:top;margin-top:0;margin-left:0;margin-right:0;margin-bottom:0;overflow:scroll;">';
    echo '<table class="background" align="center" width="100%" height="1%" valign="top" cellpadding=7 cellspacing=0 border=0><tr><td>';
	if (preg_match('/Mozilla/i', $HTTP_USER_AGENT)) {  echo '<BR>'; }
	echo $messagebody;
    echo '</td></tr>';
    echo '<tr><td>';
	do_hook('read_body_bottom');
    echo '</td></tr>';
    echo '</table>';
    echo '</div>';

sqimap_logout($imapConnection);
/* sessions are written at the end of the script. it's better to register 
   them at the end so we avoid double session_register calls */
sqsession_register($messages,'messages');

?>
</body>
</html>
