<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * addressbook.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Manage personal address book.
 *
 * $Id: search_contact.php,v 1.3 2004/05/31 14:18:32 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);
sqgetGlobalVar('sel',       $sel,           SQ_GET);

displayHtmlHeader( _("Search Addressbook"), '' );    

echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/search_contact.js"></script>';

global $fieldarrayabook;

/* Open addressbook, with error messages on but without LDAP (the *
 * second "true"). Don't need LDAP here anyway                    */
$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];

if($abook->localbackend == 0) {
    plain_error_message(
	codeHTML(_("No personal address book is defined. Contact administrator.")),
        $color);
    exit();
} else { 
    echo addForm($base_uri.'src/addressbook.php', 'POST', 'f');
    echo '<table width="100%" height="100%" class="border" cellpadding=2 cellspacing=2 border=0>';
	echo '<tr>
		<td align="left" valign="middle" class="addressbookth">'.codeHTML(_("Addressbook:")).'</td>
		<td align="left" valign="middle" class="addressbookth">'.codeHTML(_("Expression:")).'</td>
		<td align="left" valign="middle" class="addressbookth">'.codeHTML(_("Where:")).'</td>
	</tr>';
	echo '<tr>
		<td align="center" valign="middle" class="nav">';
		    $new_option = array();
		    $selected='';
		    if ($abook->numbackends > 1) {
			$new_option['-1'] = _("All address books");
			$selected = '-1';
		    }
		    // cerco su tutti i backends
		    $ret = $abook->get_backend_list(); 
		    while (list($undef,$v) = each($ret)) { $new_option[$v->bnum] = $v->sname; }
		    echo addSelect('backend', $new_option, $selected, TRUE);
		echo '</td>';
		echo '<td align="center" valign="middle" class="nav">';
		    echo addInput('stringsearch');
		echo '    </td>';
		echo '<td align="center" valign="middle" class="nav">';
		    $new_option = array();
		    foreach ($fieldarrayabook as $v => $l) {
			if ($v == "idrub" || $v == "SendPredefined" || $v == "syncr") { continue; }
			$new_option[$v] = _($l['label']);
    		    }
		    echo addSelect('fieldname', $new_option, '', TRUE);
		echo '</td>'; 
	    echo '</tr>';
	echo '<tr>'."\n";
	    echo '<td align="center" colspan=3 class="nav">';
		echo addButton(_("Close"),'','','self.close(); return false;','f','',1,1);
		echo '&nbsp;&nbsp;&nbsp;';
		echo addButton(_("Confirm"),'','','','f','OnSubmit()');
	    echo '</td>'."\n";
	echo '</tr>'."\n";    
    echo '</table>'."\n";
    echo '</form>'."\n";
echo "</BODY></HTML>\n";
}
?>