<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * signout.php -- cleans up session and logs the user out
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 *  Cleans up after the user. Resets cookies and terminates session.
 *
 * $Id: signout.php,v 1.1 2004/02/02 14:00:12 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/prefs.php');
require_once(SM_PATH . 'functions/plugin.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/global.php');

/* Erase any lingering attachments */
if (isset($attachments) && is_array($attachments) 
    && sizeof($attachments)){
    $hashed_attachment_dir = getHashedDir($username, $attachment_dir);
    foreach ($attachments as $info) {
        $attached_file = "$hashed_attachment_dir/$info[localfilename]";
        if (file_exists($attached_file)) {
            unlink($attached_file);
        }
    }
}

if (!isset($frame_top)) {
    $frame_top = '_top';
}

/* If a user hits reload on the last page, $base_uri isn't set
 * because it was deleted with the session. */
if (! sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION) ) {
    require_once(SM_PATH . 'functions/display_messages.php');
    $base_uri = sqm_baseuri();
}

do_hook('logout');

sqsession_destroy();

if ($signout_page) {
    header('Status: 303 See Other');
    header("Location: $signout_page");
    exit; /* we send no content if we're redirecting. */
}

$plugin_message = concat_hook_function('logout_above_text');

    displayHtmlHeader( _("OverLook signout"));  
    echo '<body class="bodylogin">'."\n";
    echo '<br /><br /><br /><br />'."\n";
    echo '<table align="center" valign="middle" height="25%" class="border" border="0" cellspacing="0" cellpadding="0" width="50%">'."\n";
            echo '<tr>
                    <td class="optionlink" align="center">
			'.codeHTML(_("Sign Out")).'
                    </td>
                </tr>'."\n";
	    echo $plugin_message;
            echo '<tr>
                    <td class="nav" align="center">
			'.codeHTML(_("You have been successfully signed out.")).'
                    </td>
                </tr>'."\n";
            echo '<tr>
                    <td class="optionlink" align="center">
			<a href="login.php" target="' . $frame_top . '">' . codeHTML(_("Click here to log back in.")) . '</a>
                    </td>
                </tr>'."\n";
	echo '</table>';
?>
</body>
</html>
