<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * addressbook.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Manage personal address book.
 *
 * $Id: view_info_contact.php,v 1.3 2004/05/31 14:18:32 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');

sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);
sqgetGlobalVar('sel',       $sel,           SQ_GET);

function GetVisualPhone($phone) {
    $phoneinvert = strrev($phone);
    $phonepartial = preg_replace('/(\d\d\d)/','$1.',$phoneinvert);
    $phone = strrev($phonepartial);
    $phone = preg_replace('/^\./','',$phone);
    return $phone;
}

/************************************************
* View address                       		*
*************************************************/

displayHtmlHeader( _("Addressbook"), '' );    

global $fieldarrayabook; 

/* Open addressbook, with error messages on but without LDAP (the *
 * second "true"). Don't need LDAP here anyway                    */
$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];

if($abook->localbackend == 0) {
    plain_error_message(
        codeHTML(_("No personal address book is defined. Contact administrator.")),
        $color);
    exit();
} else if (isset($sel)) {
    list($ebackend, $enick) = explode(':', $sel);
    $data = $abook->lookup_id($enick, $ebackend);
    echo '<table width="100%" height="100%" class="border" cellpadding=2 cellspacing=1 border=0>';
    foreach ($fieldarrayabook as $key => $label) {
	if ($key == "idrub" || $key == "SendPredefined" || $key == "syncr") { continue; }
	if ($key == "Cellulare" || $key == "N_tel" || $key == "N_fax") {
	    if ($data[$key]) { $data[$key] = GetVisualPhone($data[$key]); } 
	}
	$data[$key] = codeHTML($data[$key]);
	if (!$data[$key]) { $data[$key]= "&nbsp;"; }
	echo '<tr>';
	    echo '<td align="left" width="40%" class="nav">'.codeHTML(_($label['label'])).':</td>';
	    echo '<td align="left" width="60%" class="nav">'.$data[$key].'</td>';
	echo '</tr>';    
    }
    echo '<tr>';
	echo '<td align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" colspan=2 width="20%" onclick="self.close()" class="nav">'.codeHTML(_("Close")).'</td>';
    echo '</tr>';    
    echo '</table>';
}

echo "</BODY></HTML>\n";

?>